DECLARE SUB makeobject (name$, npoints%, size%)
DECLARE SUB setup ()
DECLARE SUB Cullpolygons ()
DECLARE SUB DrawObject ()
DECLARE SUB FindNormals ()
DECLARE SUB rotatepoints ()
DECLARE SUB ShadePolygons ()
REM $DYNAMIC

REM $INCLUDE: 'FUTURE.BI'
'---------------Object Variables needed for Rush Objects--------------------

' Note: I have made all arrays 10 elements long
' When you have less or more button indexes used in your program
' you can adjust the range of the arrays
'DIM SHARED launch$(1000)

CONST True = -1, False = 0
TYPE PointType
    xobject     AS INTEGER 'original coordinate
    yobject     AS INTEGER
    zobject     AS INTEGER 'rotated coordinate
    XWorld      AS INTEGER
    YWorld      AS INTEGER
    ZWorld      AS INTEGER
    xview       AS INTEGER 'rotated & translated coordinate
    yview       AS INTEGER
 '   colour      AS INTEGER

END TYPE
TYPE PolyType
    p1          AS INTEGER '3 points which make up the polygon (points
    p2          AS INTEGER 'to the point list array)
    p3          AS INTEGER
    Culled      AS INTEGER 'True if plane not visible
    ZCenter     AS INTEGER 'Z center of polygon
    ZOrder      AS INTEGER 'Used in the shell sort of the ZCenters
    intensity   AS INTEGER 'Intensity of polygon
    WorldXN     AS INTEGER 'Contains the coordinates of the point
    WorldYN     AS INTEGER ' which is both perpendicular and a constant
    WorldZN     AS INTEGER ' distance from the polygon
    NormalX     AS INTEGER 'Normal of polygon -128 to 128
    NormalY     AS INTEGER ' (used for fast Lambert shading)
    NormalZ     AS INTEGER
'    texture     AS INTEGER
END TYPE


DIM SHARED SineTable(359 + 90) AS LONG 'cos(x)=sin(x+90)
DIM SHARED r1, r2, r3, ox, oy, oz
DIM SHARED maxpoints, maxpolys, resx%, resy%
DIM SHARED PI   AS LONG
PI = 3.141593
DIM SHARED polys(2500) AS PolyType
DIM SHARED points(3700) AS PointType
DIM SHARED lx(256), ly(256), lz(256)  'lookup tables for Lambert shading

DIM SHARED lx, ly, lz
 DIM SHARED r%



'---------------------SUBS needed for Rush apllication---------------------
'loadobject "globe.3dt"
'DO
resetscreen
PRINT "3dobject generator"
PRINT "This demo will show in 3d a planet that circles around the sun. The"
PRINT "number of sides% is the numer of points for each circle and the "
PRINT "number of circles. So total number of points is sides% ^ 2"
PRINT "Thoose not to high and if you choose higher then 24 you will get "
PRINT "errors "
PRINT "Press right mousebutton to end the program"

PRINT "I tested it on a AMD DURON 650 and it doesn't lacks but on intel"
PRINT "shit it wil be very slow, hihi"
PRINT ""
PRINT "AMD POWER!!!!!!!!!, program by cyrix (cyrixramon@yahoo.com)"

IF IsMMX% THEN PRINT "MMX supported"': SetMMX 1
PRINT ""
INPUT "numer of sides% 2 - 44: ", sides%
INPUT "rotation speed of planet: ", speed%
IF speed% <= 0 THEN speed% = 1
IF speed% >= 359 THEN speed% = 359
IF sides% <= 2 THEN sides% = 2
IF sides% >= 24 THEN sides% = 24
		       
makeobject "globe", sides%, 80
DIM SHARED tv%
setup
r2 = 157
r3 = 0
Future.MouseON
    rotatepoints
    Cullpolygons
    ShadePolygons
    DrawObject

DO
Future.UpdateMouse

l1 = 90 - j%: l2 = 0         'light source's spherical coordinates
a1! = l1 / 57.29: a2! = l2 / 57.29

s1! = SIN(a1!): C1! = COS(a1!)
s2! = SIN(a2!): C2! = COS(a2!)
lx = 128 * s1! * C2!        'convert spherical coordinates to a vector
ly = 128 * s1! * s2!        'scale up by 128 for integer math
lz = 128 * C1!

FOR a = -128 TO 128         'precalculate the three light source tables
    lx(a + 128) = lx * a    'for fast Lambert shading
    ly(a + 128) = ly * a
    lz(a + 128) = lz * a
NEXT
      IF r1 = 1 THEN j% = j% + 1
      IF j% = 360 THEN j% = 0: year = year + 1
      sun% = SIN(j% * PI / 180) * 100
      sun2% = COS(j% * PI / 180) * 100
    rotatepoints
    Cullpolygons
    ShadePolygons
    DrawObject
 
    oz = oz + dz: ox = ox + dx

ox = sun2% * 4
 oz = sun% * 8 + 1600

'tijd% = VAL(MID$(TIME$, 7, 2))' / 60 * 360
'IF tijd% >= oldt% THEN r1 = r1 + 1  '((1 / (24 * 60))) * 360
'oldt% = VAL(MID$(TIME$, 7, 2))'/ 60 * 360
r1 = r1 + speed%
'r1 =
IF r1 >= 358 THEN r1 = 1
future.print 0, 0, "seconds: " + STR$(INT(r1 / 360 * 24 * 60 ^ 2)), RGB2Color(255, 255, 255), -1
future.print 0, 16, "Minutes: " + STR$(INT(r1 / 360 * 24 * 60)), RGB2Color(255, 255, 255), -1
future.print 0, 32, "Hour: " + STR$(INT(r1 / 360 * 24)), RGB2Color(255, 255, 255), -1
future.print 0, 48, "Day: " + STR$(INT(j% / 360 * 365.24)), RGB2Color(255, 255, 255), -1
future.print 0, 64, "Year: " + STR$(year), RGB2Color(255, 255, 255), -1
future.print 0, 80, "Week: " + STR$(INT(j% / 360 * 52)), RGB2Color(255, 255, 255), -1
future.print 0, 96, "Month: " + STR$(INT(j% / 360 * 12)), RGB2Color(255, 255, 255), -1
LOOP UNTIL Future.MouseB = 2
resetscreen

REM $STATIC
SUB Cullpolygons
'This algorithm for removing hidden faces was developed by Dave
'Cooper.
    'There is another method, by finding the dot product of the
    'plane's normal and the viewing vector, but this algorithm is
    'much faster because of its simplicity(and lack of floating point
    'calculations).
    FOR a = 0 TO maxpolys
	p1 = polys(a).p1
	p2 = polys(a).p2
	p3 = polys(a).p3

	IF points(p1).yview <= points(p2).yview THEN
	    IF points(p3).yview < points(p1).yview THEN
		PTop = p3
		PNext = p1
		PLast = p2
	    ELSE
		PTop = p1
		PNext = p2
		PLast = p3
	    END IF
	ELSE
	    IF points(p3).yview < points(p2).yview THEN
		PTop = p3
		PNext = p1
		PLast = p2
	    ELSE
		PTop = p2
		PNext = p3
		PLast = p1
	    END IF
	END IF

	XLow = points(PTop).xview
	YLow = points(PTop).yview

	XNext = points(PNext).xview
	XLast = points(PLast).xview

	IF XNext <= XLow AND XLast >= XLow THEN
	    polys(a).Culled = True
	ELSEIF XNext >= XLow AND XLast <= XLow THEN
	    polys(a).Culled = False
	ELSE
	    YNext = points(PNext).yview
	    YLast = points(PLast).yview
IF ((YNext - YLow) * 256&) \ (XNext - XLow) < ((YLast - YLow) * 256&) \ (XLast - XLow) THEN
		polys(a).Culled = False
	    ELSE
		polys(a).Culled = True
	    END IF
	END IF

    NEXT
END SUB

SUB DrawObject


    'Find the center of each visible polygon, and prepare the orderlist.
    numpolys = 0
    FOR a = 0 TO maxpolys
	IF polys(a).Culled = False THEN 'is this polygon visible?
	    polys(numpolys).ZOrder = a
	    numpolys = numpolys + 1
	    polys(a).ZCenter = points(polys(a).p1).ZWorld + points(polys(a).p2).ZWorld + points(polys(a).p3).ZWorld
	END IF
    NEXT
    'Sort the visible polygons by their Z center using a shell sort.
    numpolys = numpolys - 1
    Mid = (numpolys + 1) \ 2
    DO
	FOR a = 0 TO numpolys - Mid
	    CompareLow = a
	    CompareHigh = a + Mid
		DO WHILE polys(polys(CompareLow).ZOrder).ZCenter < polys(polys(CompareHigh).ZOrder).ZCenter
		SWAP polys(CompareLow).ZOrder, polys(CompareHigh).ZOrder
		CompareHigh = CompareLow
		CompareLow = CompareLow - Mid
		IF CompareLow < 0 THEN EXIT DO
	    LOOP
	NEXT
	Mid = Mid \ 2
    LOOP WHILE Mid > 0
    'Plot the visible polygons.





  'setviewport 0, 49, 823, 767
	viewpage r%
	r% = r% + 1
	IF r% = 2 THEN r% = 0
setpage r%
	
       
       future.cls 0 'RGB2Color(255, 255, 255)
       IF oz <= 1000 THEN
       Future.FillCircle resx% / 2, resy% / 1.5, 50 / 320 * resx%, RGB2Color(255, 255, 128)
       END IF
    FOR z = 0 TO numpolys
	a = polys(z).ZOrder 'which polygon do we plot?
	p1 = polys(a).p1: p2 = polys(a).p2: p3 = polys(a).p3
	'Future.Trifill (points(p1).xview), (points(p1).yview), (points(p2).xview), (points(p2).yview), (points(p3).xview), (points(p3).yview), polys(a).intensity * RGB2Color(0, 8, 16)
       
	'Future.Trigour (points(p1).xview), (points(p1).yview), (points(p2).xview), (points(p2).yview), (points(p3).xview), (points(p3).yview), points(p1).colour, points(p2).colour, points(p3).colour
	future.line (points(p1).xview), (points(p1).yview), (points(p2).xview), (points(p2).yview), polys(a).intensity * RGB2Color(0, 8, 16), -1
	future.line (points(p2).xview), (points(p2).yview), (points(p3).xview), (points(p3).yview), polys(a).intensity * RGB2Color(0, 8, 16), -1
	future.line (points(p3).xview), (points(p3).yview), (points(p1).xview), (points(p1).yview), polys(a).intensity * RGB2Color(0, 8, 16), -1
   
    NEXT
       IF oz > 1000 THEN
       Future.FillCircle resx% / 2, resy% / 1.5, 50 / 320 * resx%, RGB2Color(255, 255, 128)
       END IF

END SUB

SUB FindNormals
    FOR a = 0 TO maxpolys
	p1 = polys(a).p1: p2 = polys(a).p2: p3 = polys(a).p3

	'find the vectors of 2 lines inside the polygon
	ax! = points(p2).xobject - points(p1).xobject
	ay! = points(p2).yobject - points(p1).yobject
	az! = points(p2).zobject - points(p1).zobject

	bx! = points(p3).xobject - points(p2).xobject
	by! = points(p3).yobject - points(p2).yobject
	bz! = points(p3).zobject - points(p2).zobject

	'find the cross product of the 2 vectors
	nx! = ay! * bz! - az! * by!
	ny! = az! * bx! - ax! * bz!
	nz! = ax! * by! - ay! * bx!

	'normalize the vector so it ranges from -1 to 1
	M! = SQR(nx! * nx! + ny! * ny! + nz! * nz!)
	IF M! <> 0 THEN nx! = nx! / M!: ny! = ny! / M!: nz! = nz! / M!
	'store the vector for later rotation(notice that it is scaled
	'up by 128 so it can be stored as an integer variable)
	polys(a).WorldXN = nx! * 128 + points(p1).xobject
	polys(a).WorldYN = ny! * 128 + points(p1).yobject
	polys(a).WorldZN = nz! * 128 + points(p1).zobject
    NEXT
END SUB

SUB makeobject (name$, npoints%, size%)
pointstep% = 360 / npoints%
maxpoints% = 0
maxpolys% = 0
	  
	   FOR h% = 0 TO 360 STEP 360 / npoints%
	   x% = SIN(h% * PI / 360) * 1000
	   y% = x%
	   FOR i% = 0 TO 360 STEP 360 / npoints%
	      points(maxpoints%).xobject = SIN(i% * PI / 180) * x%
	      points(maxpoints%).zobject = COS(i% * PI / 180) * x%
	      points(maxpoints%).yobject = COS(h% * PI / 360) * 1000
	     

	     
	     
	      '(size% + size% / 2) / 255 * 255
	      IF maxpoints% > 0 THEN
	      IF points(maxpoints%).xobject = points(maxpoints% - 1).xobject AND points(maxpoints%).yobject = points(maxpoints% - 1).yobject THEN maxpoints% = maxpoints% - 1
	      END IF
	      maxpoints% = maxpoints% + 1
	   NEXT
	   NEXT
	   FOR i% = 0 TO maxpoints
	   points(i%).xobject = points(i%).xobject * (size% / 1000)
	   points(i%).yobject = points(i%).yobject * (size% / 1000)
	   points(i%).zobject = points(i%).zobject * (size% / 1000)
	   'points(i%).colour = ((points(i%).yobject + size%) / size% * 126)
	   NEXT
	   'uppoint of globe
	   FOR i% = 0 TO npoints% '- 1
		 polys(maxpolys%).p1 = 0
		 polys(maxpolys%).p2 = i% + 1
		 polys(maxpolys%).p3 = i%
		 maxpolys% = maxpolys% + 1
	   NEXT
		 polys(maxpolys%).p1 = 0
		 polys(maxpolys%).p2 = 1
		 polys(maxpolys%).p3 = npoints%
		 maxpolys% = maxpolys% + 1
		 '
		
		
		 FOR g% = 1 TO npoints% - 1
		
		 FOR i% = 1 TO npoints% '- 1
		 polys(maxpolys%).p1 = g% * npoints% - npoints% + i%
		 polys(maxpolys%).p2 = g% * npoints% + i% + 1
		 polys(maxpolys%).p3 = g% * npoints% + i%
		 maxpolys% = maxpolys% + 1
		NEXT
	       
		'polys(maxpolys%).p1 = g% * npoints%
		'polys(maxpolys%).p2 = g% * npoints% + 1
		'polys(maxpolys%).p3 = g% * npoints% + npoints%
		maxpolys% = maxpolys% + 1
		 
		  FOR i% = 1 TO npoints%' - 1
		 polys(maxpolys%).p1 = g% * npoints% - npoints% + i%
		 polys(maxpolys%).p2 = g% * npoints% - npoints% + i% + 1
		 polys(maxpolys%).p3 = g% * npoints% + i% + 1
		 maxpolys% = maxpolys% + 1
	  
		NEXT
		'polys(maxpolys%).p1 = g% * npoints%
		'polys(maxpolys%).p2 = g% * npoints% - npoints% + 1
		'polys(maxpolys%).p3 = g% * npoints% + 1
		maxpolys% = maxpolys% + 1

		 NEXT
		g% = npoints%
		FOR i% = 1 TO npoints% '- 1
		 polys(maxpolys%).p1 = g% * npoints% - npoints% + i%
		 polys(maxpolys%).p2 = g% * npoints% - npoints% + i% + 1
		 polys(maxpolys%).p3 = g% * npoints% '+ i% + 1
		 maxpolys% = maxpolys% + 1
NEXT

'
END SUB

SUB rotatepoints
'    resx% = resx% - 200
xd! = 400& * resx% / 320
yd! = 300& * resy% / 200
    'lookup the sine and cosine of each angle...
    s1& = SineTable(r1): C1& = SineTable(r1 + 90)
    s2& = SineTable(r2): C2& = SineTable(r2 + 90)
    s3& = SineTable(r3): C3& = SineTable(r3 + 90)

    'rotate the points of the object
    FOR a = 0 TO maxpoints
	xo = points(a).xobject
	yo = points(a).yobject
	zo = points(a).zobject
	GOSUB Rotate3D
	
	points(a).xview = resx% / 2 + (x2 * xd!) \ z3
	points(a).yview = resy% / 2 + (y3 * yd!) \ z3
	'IF y3 > 300 THEN STOP

	points(a).XWorld = x2
	points(a).YWorld = y3
	points(a).ZWorld = z3
   NEXT
    'rotate the normals of each polygon...
    FOR a = 0 TO maxpolys
	xo = polys(a).WorldXN
	yo = polys(a).WorldYN
	zo = polys(a).WorldZN
	GOSUB Rotate3D
	p1 = polys(a).p1
	'unorigin the point
	x2 = x2 - points(p1).XWorld
	y3 = y3 - points(p1).YWorld
	z3 = z3 - points(p1).ZWorld
	'check the bounds just in case of a round off error
	IF x2 < -128 THEN x2 = -128 ELSE IF x2 > 128 THEN x2 = 128
	IF y3 < -128 THEN y3 = -128 ELSE IF y3 > 128 THEN y3 = 128
	IF z3 < -128 THEN z3 = -128 ELSE IF z3 > 128 THEN z3 = 128
	'store the normal back; it's now ready for the shading
	'calculations (which are simplistic now)
	polys(a).NormalX = x2 + 128
	polys(a).NormalY = y3 + 128
	polys(a).NormalZ = z3 + 128
    NEXT
    ' resx% = resx% + 200
    EXIT SUB

Rotate3D:
    x1 = (xo * C1& - zo * s1&) \ 1024 'yaw
    z1 = (xo * s1& + zo * C1&) \ 1024

    z3 = (z1 * C3& - yo * s3&) \ 1024 + oz 'pitch
    y2 = (z1 * s3& + yo * C3&) \ 1024

    x2 = (x1 * C2& + y2 * s2&) \ 1024 + ox 'roll
    y3 = (y2 * C2& - x1 * s2&) \ 1024 + oy

RETURN
END SUB

SUB setup
'setup the program
     set1024x768 16
     resx% = 1024
     resy% = 768
'loadlaunch "english.lng"

x = x \ (maxpoints + 1): y = y \ (maxpoints + 1): z = z \ (maxpoints + 1)

'Precalculate the normal point of each polygon for fast Lambert shading

FindNormals

'Precalculate the sine table
a = 0

FOR a! = 0 TO (359 + 90) / 57.29 STEP 1 / 57.29
    SineTable(a) = SIN(a!) * 1024: a = a + 1
NEXT

'Some light source configurations won't work that great!



r1 = 0: r2 = 0: r3 = 0      'three angles of rotation
ox = 0: oy = 150: oz = 1300 'object's origin (this program cannot
			    'currently handle the object when it goes
		    'behind the viewer!)
s = 1: t = 0
'future.loadfont "fonts/hylas.fnt"

rotatepoints
ShadePolygons
Cullpolygons




END SUB

SUB ShadePolygons
    FOR a = 0 TO maxpolys
	IF polys(a).Culled = False THEN

	 'lookup the polygon's normal for shading
	 '(128*128)\15 = 1092
	 intensity = (lx(polys(a).NormalX) + ly(polys(a).NormalY) + lz(polys(a).NormalZ)) \ 1092
	 IF intensity < 0 THEN intensity = 0
	 intensity = intensity + 5
	 IF intensity > 15 THEN intensity = 15

	 polys(a).intensity = intensity
	END IF
    NEXT
END SUB

