DECLARE SUB Refresh ()

DECLARE SUB config ()
DECLARE SUB load ()
DECLARE FUNCTION muisx% ()
DECLARE FUNCTION muisy% ()
DECLARE SUB makeinputbox (x%, y%, length2%, instring$, Index%)
DECLARE SUB save ()
DECLARE SUB draw3d (Mode%)
DECLARE SUB blend (colour%)
DECLARE SUB Drawobject (Mode%)
DECLARE SUB makepolys ()
DECLARE SUB doxz (zoom%, x%, y%, x2%, y2%, X3%, Y3%)
DECLARE SUB dozy (zoom%, x%, y%, x2%, y2%, X3%, Y3%)
DECLARE SUB loadfile (filename$)
DECLARE SUB MakeFrame (x1%, y1%, x2%, y2%, Title$)
DECLARE SUB DrawGird (x%, y%)
DECLARE SUB drawxz (zoom%, x%, y%)
DECLARE SUB doxy (zoom%, x%, y%, x2%, y2%, X3%, Y3%)
DECLARE SUB drawxy (zoom%, x%, y%)
DECLARE SUB drawzy (zoom%, x%, y%)
DECLARE SUB CullPolygons ()
DECLARE SUB FindNormals ()
DECLARE SUB RotatePoints ()
DECLARE SUB ShadePolygons ()
DECLARE FUNCTION Dotree% (x1%, y1%, x2%, y2%, start%, tree$(), icon$())
DECLARE SUB Drawtree (x1%, y1%, x2%, y2%, start%, tree$(), icons$())
DECLARE SUB drawobjectbox (frmx%, frmy%)
DECLARE FUNCTION domenu% (x%, y%, x2%, list$(), Index%)
DECLARE SUB Makebar (x1%, y1%, x2%, y2%)
DECLARE SUB drawinform (x%, y%, x1%, y1%)
DECLARE SUB Drawwindow (vx1%, vy1%, vx2%, vy2%, topic$, Index%)
DECLARE FUNCTION DoInputBox$ (Text$, Index%)
DECLARE SUB MAKEEXIT (x%, y%, Index%)
DECLARE FUNCTION EXITPUSHED% (Index%)
DECLARE SUB makebutton (x%, y%, x2%, strg$, SIGN%, Index%)
DECLARE FUNCTION BUTTONPUSHED% (Index%, strg$)
REM $DYNAMIC
REM $INCLUDE: 'QB.BI'
REM $INCLUDE: 'future.BI'

TYPE button
  startx AS INTEGER
  starty AS INTEGER
  bwidth AS INTEGER
END TYPE
DIM SHARED BTENTRY(15) AS button, BTPUSHED%(15)

TYPE inputbox
  startx AS INTEGER
  starty AS INTEGER
  with AS INTEGER
END TYPE
DIM SHARED inputboxes(13) AS inputbox

TYPE EXITBUTTON
  startx AS INTEGER
  starty AS INTEGER
END TYPE

DIM SHARED EXITENTRY(2) AS EXITBUTTON, EXITON%(2)

CONST TRUE = -1, False = 0
TYPE PointType
    xobject     AS INTEGER 'original coordinate
    yobject     AS INTEGER
    zobject     AS INTEGER 'rotated coordinate
    XWorld      AS INTEGER
    YWorld      AS INTEGER
    zworld      AS INTEGER
    XView       AS INTEGER 'rotated & translated coordinate
    YView       AS INTEGER
END TYPE
TYPE polytype
    p1          AS INTEGER '3 points which make up the polygon (points
    p2          AS INTEGER 'to the point list array)
    p3          AS INTEGER
    culled      AS INTEGER 'True if plane not visible
    ZCenter     AS INTEGER 'Z center of polygon
    ZOrder      AS INTEGER 'Used in the shell sort of the ZCenters
    intensity   AS INTEGER 'Intensity of polygon
    WorldXN     AS INTEGER 'Contains the coordinates of the point
    WorldYN     AS INTEGER ' which is both perpendicular and a constant
    WorldZN     AS INTEGER ' distance from the polygon
    NormalX     AS INTEGER 'Normal of polygon -128 to 128
    NormalY     AS INTEGER ' (used for fast Lambert shading)
    NormalZ     AS INTEGER
    texture     AS INTEGER
END TYPE

DIM SHARED SineTable(359 + 90) AS LONG 'cos(x)=sin(x+90)
DIM SHARED r1, r2, r3, ox, oy, oz
DIM SHARED maxpoints, maxpolys

DIM SHARED polys(2000) AS polytype
DIM SHARED points(1000) AS PointType
DIM SHARED lx(256), ly(256), lz(256)  'lookup tables for Lambert shading
DIM SHARED texture%(0, 16)  'texture index%, shade index%
DIM SHARED lx, ly, lz, visble%, enablemmx%, Bitmode%, stexture%

DIM SHARED treelist$(1000)
DIM SHARED iconlist$(1)
DIM SHARED frmx%, frmy%, starttr%
DIM SHARED Menus$(10, 10)
DIM SHARED folder%

DIM SHARED frame1x%, frame1y%, frame2x%, frame2y%, frame3x%, frame3y%
DIM SHARED slblk%, maxtexture%, drawmode%
DIM formx%(2), formy%(2)
DIM SHARED lijst$(10), girdonoff%
'----------------Mouse and Rush envirnment Variables-[don't remove]---------
DIM SHARED INREGS AS RegType, OUTREGS AS RegType
DIM SHARED INREGX AS RegTypeX, OUTREGX AS RegTypeX

'CONST True = -1, False = NOT True

'---------------------SUBS needed for Rush apllication---------------------

  Bitmode% = 1
    
     Set1024x768 16 * (Bitmode% + 1)
     resx% = 1023
     resY% = 767
setmmx 1
OPEN "textures\file.tmp" FOR INPUT AS #1
DO WHILE NOT EOF(1)
INPUT #1, inline$
   
    FOR i% = 1 TO 13
    IF MID$(inline$, i% + 1, 1) = "." THEN filename$ = "textures\" + MID$(inline$, 1, i%) + ".bmp": EXIT FOR
    NEXT
    Future.LoadBMP filename$, 0, 0
    texture%(0, j%) = AllExpMem%(5000)
'    blend i% * 10
    Future.emsget 0, 0, 63, 63, texture%(0, j%)
    j% = j% + 1
LOOP
CLOSE #1
maxtexture% = j% - 1
Future.CLS 0

Future.LoadBMP "start.bmp", 312, 234

'Precalculate the normal point of each polygon for fast Lambert shading

FindNormals

'Precalculate the sine table
a = 0

FOR a! = 0 TO (359 + 90) / 57.29 STEP 1 / 57.29
    SineTable(a) = SIN(a!) * 1024: a = a + 1
NEXT

'Some light source configurations won't work that great!
l1 = 70: l2 = 40           'light source's spherical coordinates
a1! = l1 / 57.29: a2! = l2 / 57.29

s1! = SIN(a1!): C1! = COS(a1!)
s2! = SIN(a2!): C2! = COS(a2!)
lx = 128 * s1! * C2!        'convert spherical coordinates to a vector
ly = 128 * s1! * s2!        'scale up by 128 for integer math
lz = 128 * C1!

FOR a = -128 TO 128         'precalculate the three light source tables
    lx(a + 128) = lx * a    'for fast Lambert shading
    ly(a + 128) = ly * a
    lz(a + 128) = lz * a
NEXT

r1 = 0: r2 = 0: r3 = 0      'three angles of rotation
ox = 0: oy = -50: oz = 1100 'object's origin (this program cannot
			    'currently handle the object when it goes
		    'behind the viewer!)
s = 1: t = 0

treelist$(0) = "Object.3dt"
treelist$(1) = "Object.3dt\not objected"
treelist$(2) = "Object.3dt\not objected\points"
FOR i% = 0 TO maxpoints
treelist$(3 + i%) = "Object.3dt\not objected\points\point " + STR$(i%)
NEXT
treelist$(4 + maxpoints) = "Object.3dt\not objected\polys"
FOR j% = 0 TO maxpolys
treelist$(5 + maxpoints + j%) = "Object.3dt\not objected\polys\poly " + STR$(j%)
NEXT
treelist$(6 + maxpoints + maxpolys) = "Object.3dt\objects"
Menus$(0, 0) = "Delete"
Menus$(1, 0) = "Set location"

Menus$(0, 1) = "New"
Menus$(1, 1) = "Load"
Menus$(2, 1) = "Save As"
Menus$(3, 1) = "Settings"
Menus$(4, 1) = "Exit"

Menus$(0, 2) = "Copy"
Menus$(1, 2) = "Delete"
Menus$(2, 2) = "location"
Menus$(3, 2) = "Groupe"
Menus$(4, 2) = "Ungroupe"

Menus$(0, 3) = "Show Gird"
Menus$(1, 3) = "Zoom +"
Menus$(2, 3) = "Zoom -"
Menus$(3, 3) = "Texture"
Menus$(4, 3) = "gour-shaded"
Menus$(5, 3) = "tri-shaded"
Menus$(6, 3) = "wireframe"
Menus$(7, 3) = "only viseble"

Menus$(0, 5) = "Move"
Menus$(1, 5) = "Draw Poly"

 Future.LoadFONT "fonts\hylas.fnt"
' DIM SHARED foler%
 folder% = Allocatexms%(4400)
 Future.LoadBMP "map.bmp", 0, 0
 Future.XMSget 0, 0, 15, 13, folder%

drawobjectbox 843, 0
Makebar 505, 0, 842, 24

makebutton 0, 0, 79, "File", 0, 4
makebutton 80, 0, 79, "Edit", 0, 5
makebutton 160, 0, 79, "View", 0, 6
makebutton 240, 0, 79, "Insert", 0, 7
makebutton 320, 0, 79, "Tools", 0, 8
makebutton 400, 0, 79, "Help", 0, 9
makebutton 480, 0, 24, "X", 0, 10

lijst$(0) = "New 3d object..."
lijst$(1) = "Load 3d object"
lijst$(2) = "Load latest drawing"
lijst$(3) = "Settings"
lijst$(4) = "What's new..."
lijst$(5) = "Credits"
lijst$(6) = "Exit"

FOR i% = 0 TO 6
future.print 370, 400 + i% * 16, lijst$(i%), 0, -1
NEXT i%
future.MOuseON

DO
FOR i% = 0 TO 6
    IF Future.MouseX > 370 AND Future.MouseY > 400 + i% * 16 AND Future.MouseX < 370 + LEN(lijst$(i%)) * 8 AND Future.MouseY < 400 + i% * 16 + 15 THEN
      Future.MouseOFF
      future.print 370, 400 + i% * 16, lijst$(i%), RGB2Color(255, 0, 0), -1
      future.MOuseON
      DO
       future.UpdateMouse
       IF Future.MouseX < 370 OR Future.MouseY < 400 + i% * 16 OR Future.MouseX > 370 + LEN(lijst$(i%)) * 8 OR Future.MouseY > 400 + i% * 16 + 15 THEN EXIT DO
       IF Future.MouseB THEN
	    SELECT CASE i%
	    CASE 0
	    GOTO begin:
	    CASE 1
	    load
	    Refresh
	    GOTO begin:
	    CASE 3
	    config
	    CASE 6
	    ReSetScreen
	    END
	    END SELECT
       END IF
       LOOP
      Future.MouseOFF
      future.print 370, 400 + i% * 16, lijst$(i%), 0, -1
      future.MOuseON
    END IF
NEXT i%

future.UpdateMouse
LOOP
begin:
Future.MouseOFF
drawinform 0, 25, 842, 742
Future.LINE 421, 26, 421, 765, 0, -1
Future.LINE 2, 396, 840, 396, 0, -1

future.print 510, 4, "x:" + STR$(Future.MouseX) + "      y:" + STR$(Future.MouseY) + "    z:" + STR$(r2%) + STR$(g2%) + STR$(b2%), 0, RGB2Color(192, 192, 192)
zoom% = 5   '1:2

frame1x% = 200
frame1y% = 200
frame3x% = 600
frame3y% = 200
frame2x% = 200
frame2y% = 600

drawxy zoom%, frame1x%, frame1y%
drawzy zoom%, 600, 200
drawxz zoom%, 200, 600
 
   'Future.GET 860, 400 + oldr% - 16, 892, 400 + oldr% + 13, br%()
   'Future.GET 910, 400 + oldg% - 16, 942, 400 + oldg% + 13, bg%()
   'Future.GET 960, 400 + oldb% - 16, 992, 400 + oldb% + 13, bb%()

future.MOuseON
DO  'Main loop
future.UpdateMouse
'Move the first xy screen----------------------------------
IF Future.MouseB = 2 AND Future.MouseX > 2 AND Future.MouseY > 26 AND Future.MouseX < 420 AND Future.MouseY < 395 THEN
   oldx% = Future.MouseX - frame1x%
   oldy% = Future.MouseY - frame1y%
   Future.MouseOFF
   DO
     frame1x% = Future.MouseX - oldx%
     frame1y% = Future.MouseY - oldy%
     drawxy zoom%, frame1x%, frame1y%
   LOOP UNTIL Future.MouseB = 0
   future.MOuseON
END IF
'Move the second zy screen----------------------------------
IF Future.MouseB = 2 AND Future.MouseX > 422 AND Future.MouseY > 26 AND Future.MouseX < 840 AND Future.MouseY < 395 THEN
   oldx% = Future.MouseX - frame3x%
   oldy% = Future.MouseY - frame3y%
   Future.MouseOFF
   DO
     frame3x% = Future.MouseX - oldx%
     frame3y% = Future.MouseY - oldy%
     drawzy zoom%, frame3x%, frame3y%
   LOOP UNTIL Future.MouseB = 0
   future.MOuseON
END IF
'Move the second zy screen----------------------------------
IF Future.MouseB = 2 AND Future.MouseX > 2 AND Future.MouseY > 397 AND Future.MouseX < 420 AND Future.MouseY < 765 THEN
   oldx% = Future.MouseX - frame2x%
   oldy% = Future.MouseY - frame2y%
   Future.MouseOFF
   DO
     frame2x% = Future.MouseX - oldx%
     frame2y% = Future.MouseY - oldy%
     drawxz zoom%, frame2x%, frame2y%
   LOOP UNTIL Future.MouseB = 0
   future.MOuseON
END IF


future.print 510, 4, STR$(slblk%) + " x:" + STR$(Future.MouseX) + "  y:" + STR$(Future.MouseY) + "  z:" + STR$(points(slblk%).zobject), 0, RGB2Color(192, 192, 192)

'if the exit button is pushed
IF EXITPUSHED%(0) THEN
    ReSetScreen
    END
    DeallocateXMS folder%
    FOR i% = 0 TO 15
    Deallexpmem texture(0, i%)
    NEXT
END IF
'if item in the object tree is selected and right mousebutton is pushed
selec% = Dotree%(849, 30, 180, 265, starttr%, treelist$(), iconlist$())
IF selec% >= 0 AND Future.MouseB = 2 THEN
   dosl% = domenu(860, 34 + (selec% - starttr%) * 16, 140, Menus$(), 0)'make a menu
END IF
IF selec% >= 0 AND Future.MouseB = 1 THEN
   IF selec% >= 3 THEN
	   future.print 860, 320, "x: ", 0, -1
	 makeinputbox 950, 320, 50, STR$(points(selec% - 3).xobject), 10
	future.print 860, 350, "y: ", 0, -1
	 makeinputbox 950, 350, 50, STR$(points(selec% - 3).yobject), 11
	future.print 860, 380, "z: ", 0, -1
	 makeinputbox 950, 380, 50, STR$(points(selec% - 3).zobject), 12
	slblk% = selec% - 3
'        CALL Color2RGB(points(selec% - 3).colour, R%, G%, B%)
'        future.print 860, 368, "rgb:              ", 0, RGB2Color(192, 192, 192)
'        future.print 860, 368, "rgb: " + STR$(R%) + STR$(G%) + STR$(B%), 0, RGB2Color(192, 192, 192)
'        SetMaskColor colr&
'        frmx% = 843
'        Future.FILLBOX frmx% + 10, 384, frmx% + 150, 660, RGB2Color(192, 192, 192)
'        Future.FILLBOX frmx% + 10, 670, frmx% + 150, 690, RGB2Color(R%, G%, B%)
       END IF
END IF


'texture tree
'selec2% = Dotree%(849, 330, 166, 164, 0, texturelist$(), iconlist$())
'update button statics
dummy& = BUTTONPUSHED(0, "-")
dummy& = BUTTONPUSHED(1, "+")
'dummy& = BUTTONPUSHED(2, "-")
'dummy& = BUTTONPUSHED(3, "+")
dummy& = BUTTONPUSHED(4, "File")
dummy& = BUTTONPUSHED(5, "Edit")
dummy& = BUTTONPUSHED(6, "View")
dummy& = BUTTONPUSHED(7, "Insert")
dummy& = BUTTONPUSHED(8, "Tools")
dummy& = BUTTONPUSHED(9, "Help")
dummy& = BUTTONPUSHED(10, "X")
dummy& = BUTTONPUSHED(14, "Up")
dummy& = BUTTONPUSHED(15, "Down")
'IF btpushed%(10) THEN END
'move tree down
IF BTPUSHED%(1) THEN starttr% = starttr% + 1: Drawtree 849, 30, 140, 265, starttr%, treelist$(), iconlist$()
IF BTPUSHED%(0) THEN starttr% = starttr% - 1: Drawtree 849, 30, 140, 265, starttr%, treelist$(), iconlist$()

'do the file menu if button is pushed.
IF BTPUSHED%(4) THEN
filesl% = domenu(0, 25, 80, Menus$(), 1)
IF filesl% = 0 THEN
   maxpoints = 0: maxpolys = 0
   points(0).xobject = 0: points(0).yobject = 0: points(0).zobject = 0
   polys(0).p1 = 0: polys(0).p2 = 0: polys(0).p3 = 0
   Refresh
END IF
IF filesl% = 1 THEN load: Refresh
IF filesl% = 2 THEN save: Refresh
IF filesl% = 3 THEN config
IF filesl% = 4 THEN
    ReSetScreen
    END
    DeallocateXMS folder%
    FOR i% = 0 TO 15
    Deallexpmem texture(0, i%)
    NEXT
END IF

END IF
IF BTPUSHED%(5) THEN editsl% = domenu(80, 25, 80, Menus$(), 2)
IF BTPUSHED%(6) THEN
viewsl% = domenu(160, 25, 100, Menus$(), 3)
IF viewsl% = 0 THEN
   IF girdonoff% = 1 THEN
      girdonoff% = 0
      ELSE
      girdonoff% = 1
   END IF
   Refresh
END IF
IF viewsl% = 1 THEN zoom% = zoom% + 1: drawxy zoom%, frame1x%, frame1y%: drawzy zoom%, 600, 200: drawxz zoom%, 200, 600
IF viewsl% = 2 THEN zoom% = zoom% - 1: drawxy zoom%, frame1x%, frame1y%: drawzy zoom%, 600, 200: drawxz zoom%, 200, 600
IF viewsl% = 3 THEN drawmode% = 3: draw3d 3
IF viewsl% = 4 THEN drawmode% = 2: draw3d 2
IF viewsl% = 5 THEN drawmode% = 1: draw3d 1
IF viewsl% = 6 THEN drawmode% = 0: draw3d 0
IF viewsl% = 7 THEN
  IF visble% = 0 THEN
    visble% = 1
    ELSE
    visble% = 1
  END IF
  draw3d drawmode%
END IF
END IF
IF BTPUSHED%(14) THEN
   DO
   future.UpdateMouse
   LOOP UNTIL Future.MouseB = 0
   Future.MouseOFF
   IF stexture% > 0 THEN stexture% = stexture% - 1
 frmx% = 843
 drawinform frmx% + 40, 466, 68, 68
 future.emsput frmx% + 42, 468, texture(0, stexture%)
 drawinform frmx% + 22, 568, 132, 132
 future.emstritext frmx% + 24, 570, frmx% + 24 + 128, 570, frmx% + 24 + 128, 570 + 128, 0, 0, 63, 0, 63, 63, texture(0, stexture%)
 future.emstritext frmx% + 24, 570, frmx% + 24, 570 + 128, frmx% + 24 + 128, 570 + 128, 0, 0, 0, 63, 63, 63, texture(0, stexture%)
 future.MOuseON
END IF
IF BTPUSHED%(15) THEN
   DO
   future.UpdateMouse
   LOOP UNTIL Future.MouseB = 0
   Future.MouseOFF
   IF stexture% < maxtexture% THEN stexture% = stexture% + 1
 frmx% = 843
 drawinform frmx% + 40, 466, 68, 68
 future.emsput frmx% + 42, 468, texture(0, stexture%)
 drawinform frmx% + 22, 568, 132, 132
 future.emstritext frmx% + 24, 570, frmx% + 24 + 128, 570, frmx% + 24 + 128, 570 + 128, 0, 0, 63, 0, 63, 63, texture(0, stexture%)
 future.emstritext frmx% + 24, 570, frmx% + 24, 570 + 128, frmx% + 24 + 128, 570 + 128, 0, 0, 0, 63, 63, 63, texture(0, stexture%)
 future.MOuseON
END IF

IF BTPUSHED%(8) THEN toolsl% = domenu(320, 25, 80, Menus$(), 5)
doxy zoom%, frame1x%, frame1y%, frame2x%, frame2y%, frame3x%, frame3y%
doxz zoom%, frame1x%, frame1y%, frame2x%, frame2y%, frame3x%, frame3y%
dozy zoom%, frame1x%, frame1y%, frame2x%, frame2y%, frame3x%, frame3y%

    IF Future.MouseX > formx% + 410 AND Future.MouseY > formy% + 390 AND Future.MouseX < formx% + 790 AND Future.MouseY < formy% + 750 AND Future.MouseB = 2 THEN
    DO
    SetViewPort 422, 397, 840, 765
    RotatePoints
    CullPolygons
    ShadePolygons
    WAIT &H3DA, 8
    Future.CLS RGB2Color(255, 255, 255)
    Drawobject drawmode%
    FOR z = 0 TO maxpoints
	Future.FILLBOX (points(z).XView - 2), (points(z).YView) - 2, (points(z).XView) + 2, (points(z).YView) + 2, RGB2Color(128, 128, 128)
    NEXT
   
    
    'Future.MouseON
    
    r1 = Future.MouseX / (1024 / 358)
    r3 = Future.MouseY / (768 / 358)
    oz = oz + dz: ox = ox + dx
    IF oz < 600 THEN
	oz = 600: dz = 0
    ELSEIF oz > 8000 THEN
	oz = 8000: dz = 0
    END IF
    IF ox < -4000 THEN
	ox = -4000: dx = 0
    ELSEIF ox > 4000 THEN
	ox = 4000: dx = 0
    END IF
    a$ = INKEY$
    SELECT CASE a$
    CASE "4"
	D1 = D1 - 2
    CASE "6"
	D1 = D1 + 2
    CASE "8"
	D2 = D2 - 2
    CASE "2"
	D2 = D2 + 2
    CASE "5"
	D1 = 0: D2 = 0: D3 = 0
    CASE "0"
	r1 = 0: r2 = 0: r3 = 0
	D1 = 0: D2 = 0: D3 = 0
    CASE "+"
	D3 = D3 + 2
    CASE "-"
	D3 = D3 - 2
    CASE CHR$(27)
	SetViewPort 0, 0, 1024, 768
	END
	CASE CHR$(0) + CHR$(72)
	dz = dz - 20
    CASE CHR$(0) + CHR$(80)
	dz = dz + 20
    END SELECT
    LOOP UNTIL Future.MouseB = 0
    FOR z = 0 TO maxpoints
	Future.FILLBOX (points(z).XView - 2), (points(z).YView) - 2, (points(z).XView) + 2, (points(z).YView) + 2, RGB2Color(128, 128, 128)
    NEXT
    SetViewPort 0, 0, 1024, 768
    future.MOuseON
    END IF
makepolys
LOOP

REM $STATIC
SUB blend (colour%)
FOR xp% = 0 TO 63
FOR yp% = 0 TO 63
Color2RGB Future.POINT(xp%, yp%), R%, G%, B%
R% = R% + colour
IF R% <= 0 THEN R% = 0
IF R% >= 255 THEN R% = 255
G% = G% + colour
IF G% <= 0 THEN G% = 0
IF G% >= 255 THEN G% = 255
B% = B% + colour
IF B% <= 0 THEN B% = 0
IF B% >= 255 THEN B% = 255
Future.PSET xp%, yp%, RGB2Color(R%, G%, B%)
NEXT: NEXT


END SUB

DEFSNG A-Z
FUNCTION BUTTONPUSHED% (Index%, strg$)
'   Parameters in FUNCTION LOADRTI
'   -------------------------
'   INDEX%  = An Unique index identifying which button to check
'             [With the Sub MAKEBUTTON can a button with index be created]
'   STRG$   = A string indicating the Text in the specific button
'   Function result: BUTTONPUSHED% = Boolean telling button is pushed or not

'------------------------Begin of FUNCTIONCode------------------------------
	x% = BTENTRY(Index%).startx
	y% = BTENTRY(Index%).starty
	bwidth% = BTENTRY(Index%).bwidth%
	length% = bwidth%
	pushed% = (Future.MouseX >= x% AND Future.MouseX <= x% + bwidth% AND Future.MouseY >= y% AND Future.MouseY <= y% + 24)
'Future.LoadFONT "fontedit\courier.fnt"
lengt% = x2%
Caption$ = strg$
	IF pushed% AND Future.MouseB THEN
		IF NOT BTPUSHED%(Index%) THEN
				 
			BTPUSHED%(Index%) = TRUE
			Future.MouseOFF
			Future.BOX x%, y%, x% + length%, y% + 24, 0
			Future.BOX x% + 1, y% + 1, x% + length% - 1, y% + 23, RGB2Color(128, 128, 128)
			Future.FILLBOX x% + 2, y% + 2, x% + length% - 2, y% + 22, RGB2Color(192, 192, 192)
			Future.TriGour x% + 2, y% + 2, x% - 2 + length%, y% + 2, x% - 2 + length%, y% + 22, RGB2Color(255, 255, 255), RGB2Color(192, 192, 192), RGB2Color(128, 128, 128)
			Future.TriGour x% + 2, y% + 2, x% + 2, y% + 22, x% + length% - 2, y% + 22, RGB2Color(255, 255, 255), RGB2Color(192, 192, 192), RGB2Color(128, 128, 128)
		       
		       
			IF LEN(Caption$) * 8 >= length% - 16 THEN Caption$ = MID$(Caption$, 1, INT((length% - 16) / 8))
			future.print x% + length% / 2 - LEN(Caption$) * 4 + 1, y% + 7, Caption$, 0, -1
			IF Future.MouseB = 0 AND pushed% THEN BUTTONPUSHED% = TRUE
				 
			future.MOuseON
		END IF
	ELSEIF NOT pushed% OR Future.MouseB = 0 THEN
		IF BTPUSHED%(Index%) THEN
			BTPUSHED%(Index%) = False
			Future.MouseOFF
			Future.BOX x%, y%, x% + length%, y% + 24, 0
			Future.BOX x%, y%, x% + length% - 1, y% + 23, &HFFFFFF
			Future.BOX x% + 1, y% + 1, x% + length% - 1, y% + 23, RGB2Color(128, 128, 128)
			Future.BOX x% + 1, y% + 1, x% + length% - 2, y% + 22, RGB2Color(220, 220, 220)
			'Future.FILLBOX x% + 2, y% + 2, x% + length% - 2, y% + 22, RGB2Color(192, 192, 192)
			Future.TriGour x% + 2, y% + 2, x% - 2 + length%, y% + 2, x% - 2 + length%, y% + 22, RGB2Color(255, 255, 255), RGB2Color(192, 192, 192), RGB2Color(128, 128, 128)
			Future.TriGour x% + 2, y% + 2, x% + 2, y% + 22, x% + length% - 2, y% + 22, RGB2Color(255, 255, 255), RGB2Color(192, 192, 192), RGB2Color(128, 128, 128)
		       
			IF LEN(Caption$) * 8 >= length% - 16 THEN Caption$ = MID$(Caption$, 1, INT((length% - 16) / 8))
			future.print x% + length% / 2 - LEN(Caption$) * 4, y% + 6, Caption$, 0, -1
			   
			    future.MOuseON
			    END IF
	END IF
END FUNCTION

DEFINT A-Z
SUB config
Future.MouseOFF
DIM configMenus$(2, 2)
configMenus$(0, 0) = "Disabled"
configMenus$(1, 0) = "Enabled"
configMenus$(0, 1) = "High Color"
configMenus$(1, 1) = "True Color"
background% = AllExpMem%(356000)
Future.emsget 400, 300, 700, 570, background%
Drawwindow 400, 300, 300, 270, "Settingd", 2
future.print 410, 340, "MMX support: ", 0, -1
future.print 410, 380, "Bit depth:", 0, -1
MakeFrame 410, 420, 690, 560, "System information."
IF IsMMX% THEN
future.print 420, 440, "MMX processor found:    yes", 0, -1
ELSE
future.print 420, 440, "MMX processor found:    no", 0, -1
END IF

IF IsVESA% THEN
future.print 420, 460, "vesa compible video:    yes", 0, -1
ELSE
future.print 420, 460, "vesa compible video:    no", 0, -1
END IF
future.print 420, 480, "Availbe video memory:  " + STR$(VideoMemory& / 1024) + "k", 0, -1

IF enablemmx% THEN a$ = "Enabled"
IF NOT enablemmx% THEN a$ = "Disabled"
makebutton 520, 340, 135, configMenus$(enablemmx%, 0), 0, 14
IF NOT Bitmode% THEN a$ = "High Color"
IF Bitmode% THEN a$ = "True Color"
makebutton 520, 380, 135, configMenus$(INT(Bitmode%), 1), 0, 15
future.MOuseON
DO
future.UpdateMouse
dummy& = BUTTONPUSHED(14, configMenus$(enablemmx%, 0))
dummy& = BUTTONPUSHED(15, configMenus$(INT(Bitmode%), 1))

IF BTPUSHED%(14) THEN
enablemmx% = domenu%(520, 364, 135, configMenus$(), 0)
IF enablemmx% <= 0 THEN enablemmx% = 0
END IF
IF BTPUSHED%(15) THEN
Bitmode% = domenu%(520, 404, 135, configMenus$(), 1)
IF Bitmode% <= 0 THEN Bitmode% = 0
END IF
IF EXITPUSHED%(2) THEN
Future.MouseOFF
future.emsput 400, 300, background%
Deallexpmem background%
EXIT DO

END IF

LOOP
future.MOuseON

END SUB

SUB CullPolygons
'This algorithm for removing hidden faces was developed by Dave
'Cooper.
    'There is another method, by finding the dot product of the
    'plane's normal and the viewing vector, but this algorithm is
    'much faster because of its simplicity(and lack of floating point
    'calculations).
    FOR a = 0 TO maxpolys
	p1 = polys(a).p1
	p2 = polys(a).p2
	p3 = polys(a).p3

	IF points(p1).YView <= points(p2).YView THEN
	    IF points(p3).YView < points(p1).YView THEN
		PTop = p3
		PNext = p1
		PLast = p2
	    ELSE
		PTop = p1
		PNext = p2
		PLast = p3
	    END IF
	ELSE
	    IF points(p3).YView < points(p2).YView THEN
		PTop = p3
		PNext = p1
		PLast = p2
	    ELSE
		PTop = p2
		PNext = p3
		PLast = p1
	    END IF
	END IF

	XLow = points(PTop).XView
	YLow = points(PTop).YView

	XNext = points(PNext).XView
	XLast = points(PLast).XView

	IF XNext <= XLow AND XLast >= XLow THEN
	    polys(a).culled = TRUE
	ELSEIF XNext >= XLow AND XLast <= XLow THEN
	    polys(a).culled = False
	ELSE
	    YNext = points(PNext).YView
	    YLast = points(PLast).YView
IF ((YNext - YLow) * 256&) \ (XNext - XLow) < ((YLast - YLow) * 256&) \ (XLast - XLow) THEN
		polys(a).culled = False
	    ELSE
		polys(a).culled = TRUE
	    END IF
	END IF

    NEXT
END SUB

DEFSNG A-Z
FUNCTION DoInputBox$ (Text$, Index%)
cursorpos% = 1

x1% = inputboxes(Index%).startx
y1% = inputboxes(Index%).starty
x2% = inputboxes(Index%).with


IF Future.MouseX > x1% AND Future.MouseY > y1% AND Future.MouseX < x1% + x2% AND Future.MouseY < y1% + 18 THEN
IF LEN(Text$) * 8 + 8 >= x2% - 8 THEN
cursorpos% = INT(x2% / 8) - 1
ELSE
cursorpos% = LEN(Text$)
END IF
STARTtIMR& = TIMER
scrl% = 0

DO
future.UpdateMouse
future.MOuseON
IF Future.MouseB THEN
Future.FILLBOX x1% + 2, y1% + 2, x1% + x2% - 2, y1% + 22, RGB2Color(255, 255, 255)
future.print x1% + 4, y1% + 6, MID$(Text$, scrl% + 1, INT((x2% - 8) / 8)), 0, -1

DO
future.UpdateMouse
IF (Future.MouseX < x1% OR Future.MouseY < y1% OR Future.MouseX > x1% + x2% OR Future.MouseY > y1% + 18) AND Future.MouseB = 1 THEN
DoInputBox$ = Text$
Future.LINE x1% + (cursorpos% - scrl%) * 8 + 4, y1% + 4, x1% + (cursorpos% - scrl%) * 8 + 4, y1% + 20, RGB2Color(255, 255, 255), -1
EXIT FUNCTION
END IF

curtimer! = TIMER
a$ = INKEY$
IF curtimer! - STARTtIMR! >= .2 THEN
IF cl! = RGB2Color(255, 255, 255) THEN
cl! = 0
Future.MouseOFF
Future.LINE x1% + (cursorpos% - scrl%) * 8 + 4, y1% + 4, x1% + (cursorpos% - scrl%) * 8 + 4, y1% + 20, cl!, -1
future.MOuseON
ELSE
cl! = RGB2Color(255, 255, 255)
Future.MouseOFF
Future.LINE x1% + (cursorpos% - scrl%) * 8 + 4, y1% + 4, x1% + (cursorpos% - scrl%) * 8 + 4, y1% + 20, cl!, -1
future.MOuseON

END IF
STARTtIMR! = TIMER
END IF
SELECT CASE a$
 
    CASE CHR$(0) + CHR$(77)
	IF cursorpos% < LEN(Text$) THEN
	IF (cursorpos% - scrl%) * 8 + 8 >= x2% - 8 THEN scrl% = scrl% + 1
	 Future.MouseOFF
	Future.FILLBOX x1% + 2, y1% + 2, x1% + x2% - 2, y1% + 22, RGB2Color(255, 255, 255)
	Future.LINE x1% + (cursorpos% - scrl%) * 8 + 4, y1% + 4, x1% + (cursorpos% - scrl%) * 8 + 4, y1% + 20, RGB2Color(255, 255, 255), -1
	cursorpos% = cursorpos% + 1
	'Gwrite x1% + 4, y1% + 16, forecolor, text$
	'LINE (x1% + Countpixels(MID$(text$, 1, cursorpos%), 0) + 1, y1% + 2)-STEP(0, 14), forecolor
	END IF
      
	future.print x1% + 4, y1% + 6, MID$(Text$, scrl% + 1, INT((x2% - 8) / 8)), 0, -1
	future.MOuseON

    CASE CHR$(0) + CHR$(75)
      
	IF cursorpos% >= 1 THEN
	IF (cursorpos% - scrl%) * 8 <= 4 THEN scrl% = scrl% - 1
	 Future.MouseOFF
	Future.FILLBOX x1% + 2, y1% + 2, x1% + x2% - 2, y1% + 22, RGB2Color(255, 255, 255)
	Future.LINE x1% + (cursorpos% - scrl%) * 8 + 4, y1% + 4, x1% + (cursorpos% - scrl%) * 8 + 4, y1% + 20, RGB2Color(255, 255, 255), -1
	cursorpos% = cursorpos% - 1
	'Gwrite x1% + 4, y1% + 16, forecolor, text$
	'LINE (x1% + Countpixels(MID$(text$, 1, cursorpos%), 0) + 1, y1% + 2)-STEP(0, 14), forecolor
	       
	END IF
	       
	future.print x1% + 4, y1% + 6, MID$(Text$, scrl% + 1, INT((x2% - 8) / 8)), 0, -1
	future.MOuseON
 
    CASE CHR$(8)
		 Future.MouseOFF
	Future.FILLBOX x1% + 2, y1% + 2, x1% + x2% - 2, y1% + 22, RGB2Color(255, 255, 255)
	Future.LINE x1% + (cursorpos% - scrl%) * 8 + 4, y1% + 4, x1% + (cursorpos% - scrl%) * 8 + 4, y1% + 20, RGB2Color(255, 255, 255), -1
		 length% = LEN(Text$)
		 IF cursorpos% >= 1 THEN
		 IF (cursorpos% - scrl%) * 8 <= 4 THEN scrl% = scrl% - 1
		 cursorpos% = cursorpos% - 1
		 Text$ = MID$(Text$, 1, cursorpos%) + MID$(Text$, cursorpos% + 2, length% - cusorpos%)
		 END IF
      
	future.print x1% + 4, y1% + 6, MID$(Text$, scrl% + 1, INT((x2% - 8) / 8)), 0, -1
	future.MOuseON

    CASE CHR$(0) + "S"
		 Future.MouseOFF
	Future.FILLBOX x1% + 2, y1% + 2, x1% + x2% - 2, y1% + 22, RGB2Color(255, 255, 255)
	Future.LINE x1% + (cursorpos% - scrl%) * 8 + 4, y1% + 4, x1% + (cursorpos% - scrl%) * 8 + 4, y1% + 20, RGB2Color(255, 255, 255), -1
		 length% = LEN(Text$)
		 IF cursorpos% >= 0 THEN
		 Text$ = MID$(Text$, 1, cursorpos%) + MID$(Text$, cursorpos% + 2, length% - cusorpos%)
		 END IF
	       
	future.print x1% + 4, y1% + 6, MID$(Text$, scrl% + 1, INT((x2% - 8) / 8)), 0, -1
	future.MOuseON

    CASE IS > ""
    IF LEN(Text$) < 256 THEN
		 Future.MouseOFF
	Future.FILLBOX x1% + 2, y1% + 2, x1% + x2% - 2, y1% + 22, RGB2Color(255, 255, 255)
	Future.LINE x1% + (cursorpos% - scrl%) * 8 + 4, y1% + 4, x1% + (cursorpos% - scrl%) * 8 + 4, y1% + 20, RGB2Color(255, 255, 255), -1
		 cursorpos% = cursorpos% + 1
		 IF (cursorpos% - scrl%) * 8 + 8 >= x2% - 8 THEN scrl% = scrl% + 1
		 length% = LEN(Text$)
	      
		 'IF a$ = " " THEN a$ = " "
		 Text$ = MID$(Text$, 1, cursorpos% - 1) + a$ + MID$(Text$, cursorpos%, length% - ursorpos% + 1)
	       
	future.print x1% + 4, y1% + 6, MID$(Text$, scrl% + 1, INT((x2% - 8) / 8)), 0, -1
	future.MOuseON

   END IF
END SELECT
LOOP
END IF
LOOP
END IF

END FUNCTION

DEFINT A-Z
FUNCTION domenu (x%, y%, x2%, list$(), Index%)
DO
future.UpdateMouse
LOOP UNTIL Future.MouseB = 0
Future.MouseOFF
FOR i% = 0 TO 20
   IF list$(i%, Index%) = "" THEN length% = i% - 1: EXIT FOR
NEXT
REDIM handle%(0)
handle% = Allocatexms(80000)
handle2% = Allocatexms(24000)
Future.XMSget x%, y%, x% + x2%, y% + length% * 16 + 24, handle%
FOR i% = 0 TO length% * 16 STEP length% / 2 + 1
Makebar x%, y%, x% + x2%, y% + i% + 24
NEXT
FOR i% = 0 TO length%
future.print x% + 3, y% + 3 + i% * 16, list$(i%, Index%), 0, -1
NEXT

future.MOuseON
DO
future.UpdateMouse
FOR i% = 0 TO length%
onitem% = (Future.MouseX >= x% + 3 AND Future.MouseY >= y% + 3 + i% * 16 AND Future.MouseX <= x% + x2% - 3 AND Future.MouseY <= y% + 3 + i% * 16 + 15)
IF onitem% THEN
    Future.MouseOFF
    Future.XMSget x% + 3, y% + 3 + i% * 16, x% + x2% - 3, y% + 3 + i% * 16 + 15, handle2%
    FOR G% = 0 TO x2% - 6
    Future.LINE x% + 3 + G%, y% + 3 + i% * 16, x% + 3 + G%, y% + 3 + i% * 16 + 15, RGB2Color(0, 0, G% / x2% * 255), -1
   
    NEXT

    future.print x% + 3, y% + 3 + i% * 16, list$(i%, Index%), &HFFFFFF, -1
    future.MOuseON
    DO
       future.UpdateMouse
       onitem% = (Future.MouseX >= x% + 3 AND Future.MouseY >= y% + 3 + i% * 16 AND Future.MouseX <= x% + x2% - 3 AND Future.MouseY <= y% + 3 + i% * 16 + 15)
       IF NOT onitem% THEN EXIT DO
       IF onitem% AND Future.MouseB THEN
       domenu = i%
       DO
       future.UpdateMouse
       LOOP UNTIL Future.MouseB = 0
	Future.MouseOFF
	Future.XMSPUT x%, y%, handle%
	DeallocateXMS handle%
	DeallocateXMS handle2%
	future.MOuseON
       GOTO verder:
       END IF
    LOOP
    Future.MouseOFF
    Future.FILLBOX x% + 3, y% + 3 + i% * 16, x% + x2% - 3, y% + 3 + i% * 16 + 15, RGB2Color(192, 192, 192)
    Future.XMSPUT x% + 3, y% + 3 + i% * 16, handle2%
    future.print x% + 3, y% + 3 + i% * 16, list$(i%, Index%), 0, -1
    future.MOuseON
END IF
NEXT
IF (Future.MouseX < x% OR Future.MouseY < y% OR Future.MouseX > x% + x2% OR Future.MouseY > y% + 24 + i% * 16) AND Future.MouseB THEN EXIT DO
LOOP
DO
future.UpdateMouse
LOOP UNTIL Future.MouseB = 0
Future.MouseOFF
Future.XMSPUT x%, y%, handle%
DeallocateXMS handle%
DeallocateXMS handle2%
domenu = -1
verder:
future.MOuseON
END FUNCTION

FUNCTION Dotree% (x1%, y1%, x2%, y2%, start%, tree$(), icon$())
FOR i% = 0 TO 1000
    IF tree$(i%) = "" THEN treelen% = i% - 1: EXIT FOR
NEXT
'IF start% - 2 > treelen% - (y2% / 16) THEN start% = INT(treelen% - (y2% / 16))
'inframe% = (Future.MouseX >= x1% AND Future.MouseY >= y1% AND Future.MouseX <= x1% + x2% AND Future.MouseY <= y1% + y2%)
'IF inframe% THEN
'DO
'inframe% = (Future.MouseX >= x1% AND Future.MouseY >= y1% AND Future.MouseX <= x1% + x2% AND Future.MouseY <= y1% + y2%)
Dotree% = -1
FOR i% = 0 TO treelen%
    x% = 0
    FOR check% = 1 TO LEN(tree$(i% + start%))
       IF MID$(tree$(i% + start%), check%, 1) = "\" THEN
	 x% = x% + 1
	 Title$ = MID$(tree$(i% + start%), check% + 1, LEN(tree$(i% + start%)))
       END IF
    NEXT check%
       IF x% = 0 THEN Title$ = tree$(i% + start%)
      IF Future.MouseY <= y1% + y2% AND Future.MouseX >= x1% + x% * 8 + 30 AND Future.MouseY >= y1% + i% * 16 AND Future.MouseX <= x1% + x% * 8 + LEN(Title$) * 8 + 32 AND Future.MouseY <= y1% + i% * 16 + 15 THEN
	     
	     Future.MouseOFF
		 SetViewPort x1%, y1%, x1% + x2%, y1% + y2%
		 future.print x1% + x% * 8 + 28, y1% + i% * 16, Title$, &HFFFFFF, 192
		 SetViewPort 0, 0, 1023, 767
	     future.MOuseON
	 DO
	     future.UpdateMouse
	     IF Future.MouseX < x1% + x% * 8 + 30 OR Future.MouseY < y1% + i% * 16 OR Future.MouseX > x1% + x% * 8 + LEN(Title$) * 8 + 32 OR Future.MouseY > y1% + i% * 16 + 15 THEN EXIT DO
	     IF Future.MouseB THEN
		Dotree% = i% + start%
		Future.MouseOFF
			 SetViewPort x1%, y1%, x1% + x2%, y1% + y2%
			future.print x1% + x% * 8 + 28, y1% + i% * 16, Title$, 0, &HFFFFFF
		SetViewPort 0, 0, 1023, 767
		future.MOuseON
		EXIT FUNCTION
	     END IF
	     LOOP
	     Future.MouseOFF
		 SetViewPort x1%, y1%, x1% + x2%, y1% + y2%
		 future.print x1% + x% * 8 + 28, y1% + i% * 16, Title$, 0, &HFFFFFF
	     SetViewPort 0, 0, 1023, 767
	     future.MOuseON
	     
      END IF
NEXT i%
future.UpdateMouse
'LOOP UNTIL inframe% = 0
'END IF
END FUNCTION

SUB doxy (zoom%, x%, y%, x2%, y2%, X3%, Y3%)
'Setviewport 2, 26, 420, 395
IF Future.MouseX >= 2 AND Future.MouseY >= 26 AND Future.MouseX <= 420 AND Future.MouseY <= 395 THEN
     IF Future.MouseB = 1 THEN
      maxpoints = maxpoints + 1
      points(maxpoints).xobject = (Future.MouseX - x%) / (zoom% / 10)
      points(maxpoints).yobject = (Future.MouseY - y%) / (zoom% / 10)
      DO
      LOOP UNTIL Future.MouseB = 0
	frmx% = 843
	treelist$(0) = "Object.3dt"
	treelist$(1) = "Object.3dt\not objected"
	treelist$(2) = "Object.3dt\not objected\points"
	FOR i% = 0 TO maxpoints
	treelist$(3 + i%) = "Object.3dt\not objected\points\point " + STR$(i%)
	NEXT
	treelist$(4 + maxpoints) = "Object.3dt\not objected\polys"
	FOR j% = 0 TO maxpolys
	treelist$(5 + maxpoints + j%) = "Object.3dt\not objected\polys\poly " + STR$(j%)
      NEXT

	treelist$(6 + maxpoints + maxpolys) = "Object.3dt\objects"
	Drawtree frmx% + 6, frmy% + 30, 140, 265, starttr%, treelist$(), iconlist$()
	drawxy zoom%, x%, y%: drawzy zoom%, 600, 200: drawxz zoom%, 200, 600
     END IF

FOR i% = 0 TO maxpoints

  IF Future.MouseX > points(i%).xobject * (zoom% / 10) + x% - 2 AND Future.MouseY > points(i%).yobject * zoom% / 10 + y% - 2 AND Future.MouseX < points(i%).xobject * zoom% / 10 + x% + 2 AND Future.MouseY < points(i%).yobject * zoom% / 10 + y% + 2  _
THEN
     Future.FILLBOX points(i%).xobject * (zoom% / 10) + x% - 2, points(i%).yobject * zoom% / 10 + y% - 2, points(i%).xobject * zoom% / 10 + x% + 2, points(i%).yobject * zoom% / 10 + y% + 2, 255
     Future.FILLBOX points(i%).xobject * (zoom% / 10) + x2% - 2, points(i%).zobject * zoom% / 10 + y2% - 2, points(i%).xobject * zoom% / 10 + x2% + 2, points(i%).zobject * zoom% / 10 + y2% + 2, 255
     Future.FILLBOX points(i%).zobject * (zoom% / 10) + X3% - 2, points(i%).yobject * zoom% / 10 + Y3% - 2, points(i%).zobject * zoom% / 10 + X3% + 2, points(i%).yobject * zoom% / 10 + Y3% + 2, 255
    DO
    future.UpdateMouse
    IF Future.MouseX < points(i%).xobject * (zoom% / 10) + x% - 2 OR Future.MouseY < points(i%).yobject * zoom% / 10 + y% - 2 OR Future.MouseX > points(i%).xobject * zoom% / 10 + x% + 2 OR Future.MouseY > points(i%).yobject * zoom% / 10 + y% + 2  _
THEN EXIT DO
      IF Future.MouseB = 1 THEN
      REDIM behindpoint%(5 * 5 * 4 + 10)
      REDIM behindpoint2%(5 * 5 * 4 + 10)
      REDIM behindpoint3%(5 * 5 * 4 + 10)
      Future.MouseOFF
      DO
      SetViewPort 2, 26, 420, 395
      Future.PUT points(i%).xobject * (zoom% / 10) + x% - 2, points(i%).yobject * zoom% / 10 + y% - 2, behindpoint%()
      SetViewPort 2, 397, 420, 765
      Future.PUT points(i%).xobject * (zoom% / 10) + x2% - 2, points(i%).zobject * zoom% / 10 + y2% - 2, behindpoint2%()
      SetViewPort 422, 26, 840, 395
      Future.PUT points(i%).zobject * (zoom% / 10) + X3% - 2, points(i%).yobject * zoom% / 10 + Y3% - 2, behindpoint3%()
      points(i%).xobject = (Future.MouseX - x%) / (zoom% / 10)
      points(i%).yobject = (Future.MouseY - y%) / (zoom% / 10)
      SetViewPort 2, 26, 420, 395
      Future.GET points(i%).xobject * (zoom% / 10) + x% - 2, points(i%).yobject * zoom% / 10 + y% - 2, points(i%).xobject * zoom% / 10 + x% + 2, points(i%).yobject * zoom% / 10 + y% + 2, behindpoint%()
      SetViewPort 2, 397, 420, 765
      Future.GET points(i%).xobject * (zoom% / 10) + x2% - 2, points(i%).zobject * zoom% / 10 + y2% - 2, points(i%).xobject * zoom% / 10 + x2% + 2, points(i%).zobject * zoom% / 10 + y2% + 2, behindpoint2%()
      SetViewPort 422, 26, 840, 395
      Future.GET points(i%).zobject * (zoom% / 10) + X3% - 2, points(i%).yobject * zoom% / 10 + Y3% - 2, points(i%).zobject * zoom% / 10 + X3% + 2, points(i%).yobject * zoom% / 10 + Y3% + 2, behindpoint3%()
      SetViewPort 2, 26, 420, 395
      Future.FILLBOX points(i%).xobject * (zoom% / 10) + x% - 2, points(i%).yobject * zoom% / 10 + y% - 2, points(i%).xobject * zoom% / 10 + x% + 2, points(i%).yobject * zoom% / 10 + y% + 2, 255
      SetViewPort 2, 397, 420, 765
      Future.FILLBOX points(i%).xobject * (zoom% / 10) + x2% - 2, points(i%).zobject * zoom% / 10 + y2% - 2, points(i%).xobject * zoom% / 10 + x2% + 2, points(i%).zobject * zoom% / 10 + y2% + 2, 255
      SetViewPort 422, 26, 840, 395
      Future.FILLBOX points(i%).zobject * (zoom% / 10) + X3% - 2, points(i%).yobject * zoom% / 10 + Y3% - 2, points(i%).zobject * zoom% / 10 + X3% + 2, points(i%).yobject * zoom% / 10 + Y3% + 2, 255
      SetViewPort 0, 0, 1024, 768
	 future.print 860, 320, "x: ", 0, -1
	 makeinputbox 950, 320, 50, STR$(points(i%).xobject), 10
	 future.print 860, 350, "y: ", 0, -1
	 makeinputbox 950, 350, 50, STR$(points(i%).yobject), 11
	 future.print 860, 380, "z: ", 0, -1
	 makeinputbox 950, 380, 50, STR$(points(i%).zobject), 12

      LOOP UNTIL Future.MouseB = 0
      drawxy zoom%, frame1x%, frame1y%: drawzy zoom%, frame3x%, frame3y%: drawxz zoom%, frame2x%, frame2y%
      END IF
    LOOP
     Future.FILLBOX points(i%).xobject * (zoom% / 10) + x% - 2, points(i%).yobject * zoom% / 10 + y% - 2, points(i%).xobject * zoom% / 10 + x% + 2, points(i%).yobject * zoom% / 10 + y% + 2, 0
     Future.FILLBOX points(i%).xobject * (zoom% / 10) + x2% - 2, points(i%).zobject * zoom% / 10 + y2% - 2, points(i%).xobject * zoom% / 10 + x2% + 2, points(i%).zobject * zoom% / 10 + y2% + 2, 0
     Future.FILLBOX points(i%).zobject * (zoom% / 10) + X3% - 2, points(i%).yobject * zoom% / 10 + Y3% - 2, points(i%).zobject * zoom% / 10 + X3% + 2, points(i%).yobject * zoom% / 10 + Y3% + 2, 0
     future.MOuseON
  END IF
NEXT i%
'Setviewport 0, 0, 1023, 767
END IF
END SUB

SUB doxz (zoom%, x%, y%, x2%, y2%, X3%, Y3%)
IF Future.MouseX >= 2 AND Future.MouseY >= 397 AND Future.MouseX <= 420 AND Future.MouseY <= 765 THEN
     IF Future.MouseB = 1 THEN
      maxpoints = maxpoints + 1
      points(maxpoints).xobject = (Future.MouseX - x2%) / (zoom% / 10)
      points(maxpoints).zobject = (Future.MouseY - y2%) / (zoom% / 10)
      DO
      LOOP UNTIL Future.MouseB = 0
	frmx% = 843
	treelist$(0) = "Object.3dt"
	treelist$(1) = "Object.3dt\not objected"
	treelist$(2) = "Object.3dt\not objected\points"
	FOR i% = 0 TO maxpoints
	treelist$(3 + i%) = "Object.3dt\not objected\points\point " + STR$(i%)
	NEXT
	treelist$(4 + maxpoints) = "Object.3dt\not objected\polys"
	FOR j% = 0 TO maxpolys
	treelist$(5 + maxpoints + j%) = "Object.3dt\not objected\polys\poly " + STR$(j%)
      NEXT

	treelist$(6 + maxpoints + maxpolys) = "Object.3dt\objects"
	Drawtree frmx% + 6, frmy% + 30, 140, 265, 0, treelist$(), iconlist$()
	drawxy zoom%, x%, y%: drawzy zoom%, 600, 200: drawxz zoom%, 200, 600
     END IF

FOR i% = 0 TO maxpoints

  IF Future.MouseX > points(i%).xobject * (zoom% / 10) + x2% - 2 AND Future.MouseY > points(i%).zobject * zoom% / 10 + y2% - 2 AND Future.MouseX < points(i%).xobject * zoom% / 10 + X3% + 2 AND Future.MouseY < points(i%).zobject * zoom% / 10 + y2% +  _
2 THEN
     Future.FILLBOX points(i%).xobject * (zoom% / 10) + x% - 2, points(i%).yobject * zoom% / 10 + y% - 2, points(i%).xobject * zoom% / 10 + x% + 2, points(i%).yobject * zoom% / 10 + y% + 2, 255
     Future.FILLBOX points(i%).xobject * (zoom% / 10) + x2% - 2, points(i%).zobject * zoom% / 10 + y2% - 2, points(i%).xobject * zoom% / 10 + x2% + 2, points(i%).zobject * zoom% / 10 + y2% + 2, 255
     Future.FILLBOX points(i%).zobject * (zoom% / 10) + X3% - 2, points(i%).yobject * zoom% / 10 + Y3% - 2, points(i%).zobject * zoom% / 10 + X3% + 2, points(i%).yobject * zoom% / 10 + Y3% + 2, 255
    DO
    future.UpdateMouse
    IF Future.MouseX < points(i%).xobject * (zoom% / 10) + x2% - 2 OR Future.MouseY < points(i%).zobject * zoom% / 10 + y2% - 2 OR Future.MouseX > points(i%).xobject * zoom% / 10 + x2% + 2 OR Future.MouseY > points(i%).zobject * zoom% / 10 + y2% + 2 _
 THEN EXIT DO
      IF Future.MouseB = 1 THEN
      REDIM behindpoint%(5 * 5 * 4 + 10)
      REDIM behindpoint2%(5 * 5 * 4 + 10)
      REDIM behindpoint3%(5 * 5 * 4 + 10)
      DO
      SetViewPort 2, 26, 420, 395
      Future.PUT points(i%).xobject * (zoom% / 10) + x% - 2, points(i%).yobject * zoom% / 10 + y% - 2, behindpoint%()
      SetViewPort 2, 397, 420, 765
      Future.PUT points(i%).xobject * (zoom% / 10) + x2% - 2, points(i%).zobject * zoom% / 10 + y2% - 2, behindpoint2%()
      SetViewPort 422, 26, 840, 395
      Future.PUT points(i%).zobject * (zoom% / 10) + X3% - 2, points(i%).yobject * zoom% / 10 + Y3% - 2, behindpoint3%()
     
      points(i%).xobject = (Future.MouseX - x2%) / (zoom% / 10)
      points(i%).zobject = (Future.MouseY - y2%) / (zoom% / 10)
      SetViewPort 2, 26, 420, 395
      Future.GET points(i%).xobject * (zoom% / 10) + x% - 2, points(i%).yobject * zoom% / 10 + y% - 2, points(i%).xobject * zoom% / 10 + x% + 2, points(i%).yobject * zoom% / 10 + y% + 2, behindpoint%()
      SetViewPort 2, 397, 420, 765
      Future.GET points(i%).xobject * (zoom% / 10) + x2% - 2, points(i%).zobject * zoom% / 10 + y2% - 2, points(i%).xobject * zoom% / 10 + x2% + 2, points(i%).zobject * zoom% / 10 + y2% + 2, behindpoint2%()
      SetViewPort 422, 26, 840, 395
      Future.GET points(i%).zobject * (zoom% / 10) + X3% - 2, points(i%).yobject * zoom% / 10 + Y3% - 2, points(i%).zobject * zoom% / 10 + X3% + 2, points(i%).yobject * zoom% / 10 + Y3% + 2, behindpoint3%()
      SetViewPort 2, 26, 420, 395
      Future.FILLBOX points(i%).xobject * (zoom% / 10) + x% - 2, points(i%).yobject * zoom% / 10 + y% - 2, points(i%).xobject * zoom% / 10 + x% + 2, points(i%).yobject * zoom% / 10 + y% + 2, 255
      SetViewPort 2, 397, 420, 765
      Future.FILLBOX points(i%).xobject * (zoom% / 10) + x2% - 2, points(i%).zobject * zoom% / 10 + y2% - 2, points(i%).xobject * zoom% / 10 + x2% + 2, points(i%).zobject * zoom% / 10 + y2% + 2, 255
      SetViewPort 422, 26, 840, 395
      Future.FILLBOX points(i%).zobject * (zoom% / 10) + X3% - 2, points(i%).yobject * zoom% / 10 + Y3% - 2, points(i%).zobject * zoom% / 10 + X3% + 2, points(i%).yobject * zoom% / 10 + Y3% + 2, 255
      SetViewPort 0, 0, 1024, 768
	 future.print 860, 320, "x: ", 0, -1
	 makeinputbox 950, 320, 50, STR$(points(i%).xobject), 10
	 future.print 860, 350, "y: ", 0, -1
	 makeinputbox 950, 350, 50, STR$(points(i%).yobject), 11
	 future.print 860, 380, "z: ", 0, -1
	 makeinputbox 950, 380, 50, STR$(points(i%).zobject), 12


      LOOP UNTIL Future.MouseB = 0
	   drawxy zoom%, frame1x%, frame1y%: drawzy zoom%, frame3x%, frame3y%: drawxz zoom%, frame2x%, frame2y%
      END IF
    LOOP
     Future.FILLBOX points(i%).xobject * (zoom% / 10) + x% - 2, points(i%).yobject * zoom% / 10 + y% - 2, points(i%).xobject * zoom% / 10 + x% + 2, points(i%).yobject * zoom% / 10 + y% + 2, 0
     Future.FILLBOX points(i%).xobject * (zoom% / 10) + x2% - 2, points(i%).zobject * zoom% / 10 + y2% - 2, points(i%).xobject * zoom% / 10 + x2% + 2, points(i%).zobject * zoom% / 10 + y2% + 2, 0
     Future.FILLBOX points(i%).zobject * (zoom% / 10) + X3% - 2, points(i%).yobject * zoom% / 10 + Y3% - 2, points(i%).zobject * zoom% / 10 + X3% + 2, points(i%).yobject * zoom% / 10 + Y3% + 2, 0
  END IF
NEXT i%
END IF
END SUB

SUB dozy (zoom%, x%, y%, x2%, y2%, X3%, Y3%)
'422, 26, 840, 395
IF Future.MouseX >= 422 AND Future.MouseY >= 26 AND Future.MouseX <= 840 AND Future.MouseY <= 395 THEN
     IF Future.MouseB = 1 THEN
      maxpoints = maxpoints + 1
      points(maxpoints).zobject = (Future.MouseX - X3%) / (zoom% / 10)
      points(maxpoints).yobject = (Future.MouseY - Y3%) / (zoom% / 10)
      DO
      LOOP UNTIL Future.MouseB = 0
	frmx% = 843
	treelist$(0) = "Object.3dt"
	treelist$(1) = "Object.3dt\not objected"
	treelist$(2) = "Object.3dt\not objected\points"
	FOR i% = 0 TO maxpoints
	treelist$(3 + i%) = "Object.3dt\not objected\points\point " + STR$(i%)
	NEXT
	treelist$(4 + maxpoints) = "Object.3dt\not objected\polys"
	FOR j% = 0 TO maxpolys
	treelist$(5 + maxpoints + j%) = "Object.3dt\not objected\polys\poly " + STR$(j%)
      NEXT

	treelist$(6 + maxpoints + maxpolys) = "Object.3dt\objects"
	Drawtree frmx% + 6, frmy% + 30, 140, 265, 0, treelist$(), iconlist$()
	drawxy zoom%, x%, y%: drawzy zoom%, 600, 200: drawxz zoom%, 200, 600
     END IF

FOR i% = 0 TO maxpoints

  IF Future.MouseX > points(i%).zobject * (zoom% / 10) + X3% - 2 AND Future.MouseY > points(i%).yobject * zoom% / 10 + Y3% - 2 AND Future.MouseX < points(i%).zobject * zoom% / 10 + X3% + 2 AND Future.MouseY < points(i%).yobject * zoom% / 10 + Y3% +  _
2 THEN
     Future.FILLBOX points(i%).xobject * (zoom% / 10) + x% - 2, points(i%).yobject * zoom% / 10 + y% - 2, points(i%).xobject * zoom% / 10 + x% + 2, points(i%).yobject * zoom% / 10 + y% + 2, 255
     Future.FILLBOX points(i%).xobject * (zoom% / 10) + x2% - 2, points(i%).zobject * zoom% / 10 + y2% - 2, points(i%).xobject * zoom% / 10 + x2% + 2, points(i%).zobject * zoom% / 10 + y2% + 2, 255
     Future.FILLBOX points(i%).zobject * (zoom% / 10) + X3% - 2, points(i%).yobject * zoom% / 10 + Y3% - 2, points(i%).zobject * zoom% / 10 + X3% + 2, points(i%).yobject * zoom% / 10 + Y3% + 2, 255
    DO
    future.UpdateMouse
    IF Future.MouseX < points(i%).zobject * (zoom% / 10) + X3% - 2 OR Future.MouseY < points(i%).yobject * zoom% / 10 + Y3% - 2 OR Future.MouseX > points(i%).zobject * zoom% / 10 + X3% + 2 OR Future.MouseY > points(i%).yobject * zoom% / 10 + Y3% + 2 _
 THEN EXIT DO
      IF Future.MouseB = 1 THEN
      REDIM behindpoint%(5 * 5 * 4 + 10)
      DO
      Future.PUT points(i%).xobject * (zoom% / 10) + x% - 2, points(i%).yobject * zoom% / 10 + y% - 2, behindpoint%()
      points(i%).zobject = (Future.MouseX - X3%) / (zoom% / 10)
      points(i%).yobject = (Future.MouseY - Y3%) / (zoom% / 10)
      Future.GET points(i%).xobject * (zoom% / 10) + x% - 2, points(i%).yobject * zoom% / 10 + y% - 2, points(i%).xobject * zoom% / 10 + x% + 2, points(i%).yobject * zoom% / 10 + y% + 2, behindpoint%()
     Future.FILLBOX points(i%).xobject * (zoom% / 10) + x% - 2, points(i%).yobject * zoom% / 10 + y% - 2, points(i%).xobject * zoom% / 10 + x% + 2, points(i%).yobject * zoom% / 10 + y% + 2, 255
     Future.FILLBOX points(i%).xobject * (zoom% / 10) + x2% - 2, points(i%).zobject * zoom% / 10 + y2% - 2, points(i%).xobject * zoom% / 10 + x2% + 2, points(i%).zobject * zoom% / 10 + y2% + 2, 255
     Future.FILLBOX points(i%).zobject * (zoom% / 10) + X3% - 2, points(i%).yobject * zoom% / 10 + Y3% - 2, points(i%).zobject * zoom% / 10 + X3% + 2, points(i%).yobject * zoom% / 10 + Y3% + 2, 255
	 future.print 860, 320, "x: ", 0, -1
	 makeinputbox 950, 320, 50, STR$(points(i%).xobject), 10
	 future.print 860, 350, "y: ", 0, -1
	 makeinputbox 950, 350, 50, STR$(points(i%).yobject), 11
	 future.print 860, 380, "z: ", 0, -1
	 makeinputbox 950, 380, 50, STR$(points(i%).zobject), 12


      LOOP UNTIL Future.MouseB = 0
      drawxy zoom%, frame1x%, frame1y%: drawzy zoom%, frame3x%, frame3y%: drawxz zoom%, frame2x%, frame2y%
      END IF
    LOOP
     Future.FILLBOX points(i%).xobject * (zoom% / 10) + x% - 2, points(i%).yobject * zoom% / 10 + y% - 2, points(i%).xobject * zoom% / 10 + x% + 2, points(i%).yobject * zoom% / 10 + y% + 2, 0
     Future.FILLBOX points(i%).xobject * (zoom% / 10) + x2% - 2, points(i%).zobject * zoom% / 10 + y2% - 2, points(i%).xobject * zoom% / 10 + x2% + 2, points(i%).zobject * zoom% / 10 + y2% + 2, 0
     Future.FILLBOX points(i%).zobject * (zoom% / 10) + X3% - 2, points(i%).yobject * zoom% / 10 + Y3% - 2, points(i%).zobject * zoom% / 10 + X3% + 2, points(i%).yobject * zoom% / 10 + Y3% + 2, 0
  END IF
NEXT i%

'Setviewport 0, 0, 1023, 767
END IF

END SUB

SUB draw3d (Mode%)
    SetViewPort 422, 397, 840, 765
    RotatePoints
    IF NOT visble% THEN
    CullPolygons
    ELSE
    FOR a = 0 TO maxpolys
    polys(a).culled = 0
    NEXT
    END IF
    ShadePolygons
    WAIT &H3DA, 8
    Future.CLS RGB2Color(255, 255, 255)
    Drawobject Mode%
    SetViewPort 0, 0, 1024, 768

END SUB

SUB DrawGird (x%, y%)
IF girdonoff% THEN
FOR xp% = 0 TO 53
     Future.LINE x% + xp% * 8, u%, x% + xp% * 8, y% + 400, RGB2Color(220, 220, 220), -1
NEXT
FOR yp% = 0 TO 47
Future.LINE x%, y% + yp% * 8, x% + 500, y% + yp% * 8, RGB2Color(220, 220, 220), -1
NEXT
END IF
END SUB

SUB drawinform (x%, y%, x1%, y1%)
 Future.BOX x%, y%, x% + x1%, y% + y1%, &HFFFFFF
 Future.BOX x%, y%, x% + x1% - 1, y% + y1% - 1, RGB2Color(128, 128, 128)
 Future.BOX x% + 1, y% + 1, x% + x1% - 1, y% + y1% - 1, RGB2Color(220, 220, 220)
 Future.BOX x% + 1, y% + 1, x% + x1% - 2, y% + y1% - 2, &H0
 Future.FILLBOX x% + 2, y% + 2, x% + x1% - 2, y% + y1% - 2, &HFFFFFF
END SUB

SUB Drawobject (Mode%)


    'Find the center of each visible polygon, and prepare the orderlist.
    numpolys = 0
    FOR a = 0 TO maxpolys
	IF polys(a).culled = False THEN 'is this polygon visible?
	    polys(numpolys).ZOrder = a
	    numpolys = numpolys + 1
	    polys(a).ZCenter = points(polys(a).p1).zworld + points(polys(a).p2).zworld + points(polys(a).p3).zworld
	END IF
    NEXT
    'Sort the visible polygons by their Z center using a shell sort.
    numpolys = numpolys - 1
    Mid = (numpolys + 1) \ 2
    DO
	FOR a = 0 TO numpolys - Mid
	    CompareLow = a
	    CompareHigh = a + Mid
		DO WHILE polys(polys(CompareLow).ZOrder).ZCenter < polys(polys(CompareHigh).ZOrder).ZCenter
		SWAP polys(CompareLow).ZOrder, polys(CompareHigh).ZOrder
		CompareHigh = CompareLow
		CompareLow = CompareLow - Mid
		IF CompareLow < 0 THEN EXIT DO
	    LOOP
	NEXT
	Mid = Mid \ 2
    LOOP WHILE Mid > 0
    'Plot the visible polygons.
    FOR z = 0 TO numpolys
	a = polys(z).ZOrder 'which polygon do we plot?
	p1 = polys(a).p1: p2 = polys(a).p2: p3 = polys(a).p3
	SELECT CASE Mode%
	CASE 0 'wireframe
	Future.LINE (points(p1).XView), (points(p1).YView), (points(p2).XView), (points(p2).YView), 0, -1
	Future.LINE (points(p2).XView), (points(p2).YView), (points(p3).XView), (points(p3).YView), 0, -1
	Future.LINE (points(p3).XView), (points(p3).YView), (points(p1).XView), (points(p1).YView), 0, -1
	CASE 1 'solid polygon
	Future.TRIFILL (points(p1).XView), (points(p1).YView), (points(p2).XView), (points(p2).YView), (points(p3).XView), (points(p3).YView), RGB2Color(polys(a).intensity * 8, polys(a).intensity * 8, polys(a).intensity * 8)
	CASE 2 'gour shaded
	Future.TriGour (points(p1).XView), (points(p1).YView), (points(p2).XView), (points(p2).YView), (points(p3).XView), (points(p3).YView), points(p1).zobject, points(p2).zobject, points(p3).zobject
	future.print 700, 500, STR$(points(0).zworld), RGB2Color(255, 255, 255), RGB2Color(128, 128, 128)
	CASE 3  'texture shaded
	future.emstritext (points(p1).XView), (points(p1).YView), (points(p2).XView), (points(p2).YView), (points(p3).XView), (points(p3).YView), 0, 31, 63, 0, 63, 63, texture%(0, polys(a).texture)
       END SELECT
    NEXT
END SUB

SUB drawobjectbox (frmx%, frmy%)
Drawwindow frmx%, frmy%, 180, 767, "Object", 0
drawinform frmx% + 4, frmy% + 26, 172, 270
Drawtree frmx% + 6, frmy% + 30, 140, 265, 0, treelist$(), iconlist$()
Future.FILLBOX frmx% + 150, frmy% + 28, frmx% + 174, frmy% + 294, RGB2Color(192, 192, 192)
makebutton frmx% + 150, frmy% + 28, 24, "-", 0, 0
makebutton frmx% + 150, frmy% + 270, 24, "+", 0, 1
MakeFrame frmx% + 6, 305, frmx% + 170, 420, "Point statics"
MakeFrame frmx% + 6, 430, frmx% + 170, 760, "Textures"
 makebutton frmx% + 40, 440, 68, "Up", 0, 14
 makebutton frmx% + 40, 534, 68, "Down", 0, 15
 drawinform frmx% + 40, 466, 68, 68
 future.emsput frmx% + 42, 468, texture(0, 0)
 drawinform frmx% + 22, 568, 132, 132
 future.emstritext frmx% + 24, 570, frmx% + 24 + 128, 570, frmx% + 24 + 128, 570 + 128, 0, 0, 63, 0, 63, 63, texture(0, 0)
 future.emstritext frmx% + 24, 570, frmx% + 24, 570 + 128, frmx% + 24 + 128, 570 + 128, 0, 0, 0, 63, 63, 63, texture(0, 0)
END SUB

SUB Drawtree (x1%, y1%, x2%, y2%, start%, tree$(), icons$())
SetViewPort x1%, y1%, x1% + x2%, y1% + y2%
Future.CLS RGB2Color(255, 255, 255)
FOR i% = 0 TO 1000
    IF tree$(i%) = "" THEN treelen% = i% - 1: EXIT FOR
NEXT
IF start% <= 0 THEN start% = 0
IF start% >= treelen% THEN start% = treelen%
'IF start% - 2 > treelen% - (y2% / 16) THEN start% = INT(treelen% - (y2% / 16))
FOR i% = 0 TO treelen%
    x% = 0
    FOR check% = 1 TO LEN(tree$(i% + start%))
       IF MID$(tree$(i% + start%), check%, 1) = "\" THEN
	 x% = x% + 1
	 Title$ = MID$(tree$(i% + start%), check% + 1, LEN(tree$(i% + start%)))
       END IF
    NEXT check%
       IF x% = 0 THEN Title$ = tree$(i% + start%)
    IF x% >= 1 THEN
       FOR ln% = 1 TO x%
	  Future.LINE x1% + ln% * 8, y1% + i% * 16, x1% + ln% * 8, y1% + i% * 16 + 15, RGB2Color(128, 128, 128), &HAAAA
       NEXT ln%
    END IF
      'Future.LoadBMP "map.bmp", X1% + x% * 8 + 8, y1% + I% * 16
      Future.XMSPUT x1% + x% * 8 + 8, y1% + i% * 16, folder%
      future.print x1% + x% * 8 + 28, y1% + i% * 16, Title$, 0, &HFFFFFF
      IF x% >= 1 THEN Future.LINE x1% + x% * 8, y1% + i% * 16 + 8, x1% + x% * 8 + 6, y1% + i% * 16 + 8, RGB2Color(128, 128, 128), &HAAAA
NEXT i%
SetViewPort 0, 0, 1023, 767
END SUB

DEFSNG A-Z
SUB Drawwindow (vx1%, vy1%, vx2%, vy2%, topic$, Index%)
Future.MouseOFF
x% = vx1%
y% = vy1%
x1% = vx1%
y1% = vy1%
x2% = vx2% + vx1%
y2% = vy2% + vy1%

xwith% = vx2%
ywith% = vy2%
Future.BOX x%, y%, x% + xwith%, y% + ywith%, 0
Future.BOX x%, y%, x% + xwith% - 1, y% + ywith% - 1, RGB2Color(220, 220, 220)
Future.BOX x% + 1, y% + 1, x% + xwith% - 1, y% + ywith% - 1, RGB2Color(128, 128, 128)
Future.BOX x% + 1, y% + 1, x% + xwith% - 2, y% + ywith% - 2, &HFFFFFF
Future.FILLBOX x% + 2, y% + 2, x% + xwith% - 2, y% + ywith% - 2, RGB2Color(192, 192, 192)

Future.TriGour x1% + 2, y1% + 2, x2% - 2, y1% + 2, x2% - 2, y2% - 2, RGB2Color(255, 255, 255), RGB2Color(192, 192, 192), RGB2Color(128, 128, 128)
Future.TriGour x1% + 2, y1% + 2, x1% + 2, y2% - 2, x2% - 2, y2% - 2, RGB2Color(255, 255, 255), RGB2Color(192, 192, 192), RGB2Color(128, 128, 128)
 
C = 128 / xwith%
FOR gf% = 0 TO xwith% - 8
B% = 128 + gf% * C
G% = gf% * C
Future.LINE x% + 4 + gf%, y% + 4, x% + 4 + gf%, y% + 22, RGB2Color(R%, G%, B%), -1
'(r% * &H10000) + (g% * &H100&) + b%, -1
NEXT
future.print x% + 6, y% + 6, topic$, &HFFFFFF, -1
Future.LoadBMP "exit1.bmp", x% + xwith% - 22, y% + 6
MAKEEXIT x% + xwith% - 22, y% + 6, Index%
END SUB

DEFINT A-Z
SUB drawxy (zoom%, x%, y%)
SetViewPort 2, 26, 420, 395
'zoom% = zoom% / 10
Future.CLS &HFFFFFF
DrawGird 2, 26
FOR P% = 0 TO maxpolys

 Future.LINE points(polys(P%).p1).xobject * zoom% / 10 + x%, points(polys(P%).p1).yobject * zoom% / 10 + y%, points(polys(P%).p2).xobject * zoom% / 10 + x%, points(polys(P%).p2).yobject * zoom% / 10 + y%, &H0, -1
 Future.LINE points(polys(P%).p2).xobject * zoom% / 10 + x%, points(polys(P%).p2).yobject * zoom% / 10 + y%, points(polys(P%).p3).xobject * zoom% / 10 + x%, points(polys(P%).p3).yobject * zoom% / 10 + y%, &H0, -1
 Future.LINE points(polys(P%).p3).xobject * zoom% / 10 + x%, points(polys(P%).p3).yobject * zoom% / 10 + y%, points(polys(P%).p1).xobject * zoom% / 10 + x%, points(polys(P%).p1).yobject * zoom% / 10 + y%, &H0, -1
NEXT P%
FOR i% = 0 TO maxpoints
  Future.FILLBOX points(i%).xobject * zoom% / 10 + x% - 2, points(i%).yobject * zoom% / 10 + y% - 2, points(i%).xobject * zoom% / 10 + x% + 2, points(i%).yobject * zoom% / 10 + y% + 2, 0
NEXT i%
SetViewPort 0, 0, 1023, 767
END SUB

SUB drawxz (zoom%, x%, y%)
SetViewPort 2, 397, 420, 765
'zoom% = zoom% / 10
Future.CLS &HFFFFFF
DrawGird 2, 397
FOR P% = 0 TO maxpolys
 Future.LINE points(polys(P%).p1).xobject * zoom% / 10 + x%, points(polys(P%).p1).zobject * zoom% / 10 + y%, points(polys(P%).p2).xobject * zoom% / 10 + x%, points(polys(P%).p2).zobject * zoom% / 10 + y%, &H0, -1
 Future.LINE points(polys(P%).p2).xobject * zoom% / 10 + x%, points(polys(P%).p2).zobject * zoom% / 10 + y%, points(polys(P%).p3).xobject * zoom% / 10 + x%, points(polys(P%).p3).zobject * zoom% / 10 + y%, &H0, -1
 Future.LINE points(polys(P%).p3).xobject * zoom% / 10 + x%, points(polys(P%).p3).zobject * zoom% / 10 + y%, points(polys(P%).p1).xobject * zoom% / 10 + x%, points(polys(P%).p1).zobject * zoom% / 10 + y%, &H0, -1
NEXT P%
FOR i% = 0 TO maxpoints
  Future.FILLBOX points(i%).xobject * (zoom% / 10) + x% - 2, points(i%).zobject * zoom% / 10 + y% - 2, points(i%).xobject * zoom% / 10 + x% + 2, points(i%).zobject * zoom% / 10 + y% + 2, 0
NEXT i%
SetViewPort 0, 0, 1023, 767

END SUB

SUB drawzy (zoom%, x%, y%)
SetViewPort 422, 26, 840, 395
'zoom% = zoom% / 10
Future.CLS &HFFFFFF
DrawGird 422, 26
FOR P% = 0 TO maxpolys
 Future.LINE points(polys(P%).p1).zobject * zoom% / 10 + x%, points(polys(P%).p1).yobject * zoom% / 10 + y%, points(polys(P%).p2).zobject * zoom% / 10 + x%, points(polys(P%).p2).yobject * zoom% / 10 + y%, &H0, -1
 Future.LINE points(polys(P%).p2).zobject * zoom% / 10 + x%, points(polys(P%).p2).yobject * zoom% / 10 + y%, points(polys(P%).p3).zobject * zoom% / 10 + x%, points(polys(P%).p3).yobject * zoom% / 10 + y%, &H0, -1
 Future.LINE points(polys(P%).p3).zobject * zoom% / 10 + x%, points(polys(P%).p3).yobject * zoom% / 10 + y%, points(polys(P%).p1).zobject * zoom% / 10 + x%, points(polys(P%).p1).yobject * zoom% / 10 + y%, &H0, -1
NEXT P%
FOR i% = 0 TO maxpoints
  Future.FILLBOX points(i%).zobject * (zoom% / 10) + x% - 2, points(i%).yobject * zoom% / 10 + y% - 2, points(i%).zobject * zoom% / 10 + x% + 2, points(i%).yobject * zoom% / 10 + y% + 2, 0
NEXT i%
SetViewPort 0, 0, 1023, 767

END SUB

DEFSNG A-Z
FUNCTION EXITPUSHED% (Index%)
startx% = EXITENTRY(Index%).startx
starty% = EXITENTRY(Index%).starty
ACTIVE% = (Future.MouseX >= startx% AND Future.MouseX <= startx% + 16 AND Future.MouseY >= starty% AND Future.MouseY <= starty% + 14)
pushed% = (ACTIVE% AND EXITON%(Index%) AND Future.MouseB = 0)

IF ACTIVE% AND EXITON%(Index%) = False AND Future.MouseB THEN
	EXITON%(Index%) = TRUE
	Future.MouseOFF

	vx1% = startx%: vy1% = starty%
	Future.LoadBMP "exit2.bmp", vx1%, vy1%
	future.MOuseON
ELSEIF NOT ACTIVE% AND EXITON%(Index%) OR pushed% THEN
	EXITON%(Index%) = False
	Future.MouseOFF
	vx1% = startx%: vy1% = starty%
	Future.LoadBMP "exit1.bmp", vx1%, vy1%
	future.MOuseON
END IF
EXITPUSHED% = pushed%
END FUNCTION

SUB EXITSIGN (x%, y%, OnOff%)
'Future.MouseOn
IF OnOff% = ENABLE% THEN 'EXITSIGN ENABLED
	PSET (x%, y%), forecolor
	DRAW "bd5br14C" + STR$(forecolor) + "d2br2ebrbd3l2bd2fhbl2d2u2bl2gebu2l2r2bu2h"
ELSE ' EXITSIGN DISABLED
	PSET (x%, y%), forecolor
	DRAW "bd5br14C" + STR$(backcolor) + "d2br2ebrbd3l2bd2fhbl2d2u2bl2gebu2l2r2bu2h"
END IF
END SUB

DEFINT A-Z
SUB FindNormals
    FOR a = 0 TO maxpolys
	p1 = polys(a).p1: p2 = polys(a).p2: p3 = polys(a).p3

	'find the vectors of 2 lines inside the polygon
	ax! = points(p2).xobject - points(p1).xobject
	ay! = points(p2).yobject - points(p1).yobject
	az! = points(p2).zobject - points(p1).zobject

	bx! = points(p3).xobject - points(p2).xobject
	by! = points(p3).yobject - points(p2).yobject
	bz! = points(p3).zobject - points(p2).zobject

	'find the cross product of the 2 vectors
	nx! = ay! * bz! - az! * by!
	ny! = az! * bx! - ax! * bz!
	nz! = ax! * by! - ay! * bx!

	'normalize the vector so it ranges from -1 to 1
	M! = SQR(nx! * nx! + ny! * ny! + nz! * nz!)
	IF M! <> 0 THEN nx! = nx! / M!: ny! = ny! / M!: nz! = nz! / M!
	'store the vector for later rotation(notice that it is scaled
	'up by 128 so it can be stored as an integer variable)
	polys(a).WorldXN = nx! * 128 + points(p1).xobject
	polys(a).WorldYN = ny! * 128 + points(p1).yobject
	polys(a).WorldZN = nz! * 128 + points(p1).zobject
    NEXT
END SUB

SUB load
Future.MouseOFF
background% = AllExpMem%(256000)
Future.emsget 400, 300, 700, 470, background%
Drawwindow 400, 300, 300, 170, "Open file", 2
future.print 410, 330, "Path:", 0, -1
fpath$ = ""
makeinputbox 410, 350, 280, "", 0
future.print 410, 380, "Filename:", 0, -1
ffilename$ = ""
makeinputbox 410, 400, 280, "", 1
makebutton 410, 440, 135, "Open", 0, 11
makebutton 555, 440, 135, "Cancel", 0, 12
future.MOuseON
DO
future.UpdateMouse
IF path$ > "" THEN fpath$ = path$
path$ = DoInputBox(fpath$, 0)
IF filename$ > "" THEN ffilename$ = filename$
filename$ = DoInputBox(ffilename$, 1)

dummy& = BUTTONPUSHED(11, "Open")
dummy& = BUTTONPUSHED(12, "Cancel")
IF BTPUSHED%(11) THEN
loadfile fpath$ + ffilename$ + ".3dt"
Future.MouseOFF
future.emsput 400, 300, background%
EXIT DO
END IF
IF EXITPUSHED%(2) OR BTPUSHED%(12) THEN
Future.MouseOFF
future.emsput 400, 300, background%
EXIT DO

END IF

LOOP
future.MOuseON

END SUB

SUB loadfile (filename$)
	       OPEN filename$ FOR INPUT AS #1
		      INPUT #1, inline$
		      maxpoints = VAL(inline$)
		      FOR ln% = 0 TO maxpoints
			INPUT #1, inline$
			points(ln%).xobject = VAL(inline$)
			INPUT #1, inline$
			points(ln%).yobject = VAL(inline$)
			INPUT #1, inline$
			points(ln%).zobject = VAL(inline$)
			NEXT
		      INPUT #1, inline$
		      maxpolys = VAL(inline$)
		      FOR ln% = 0 TO maxpolys
		       INPUT #1, inline$
			polys(ln%).p1 = VAL(inline$)
			INPUT #1, inline$
			polys(ln%).p2 = VAL(inline$)
			INPUT #1, inline$
			polys(ln%).p3 = VAL(inline$)
			'INPUT #1, textu$
			polys(ln%).texture = INT(RND * 10)
		      NEXT
		CLOSE #1

END SUB

DEFSNG A-Z
SUB Makebar (x1%, y1%, x2%, y2%)
Future.BOX x1%, y1%, x2%, y2%, 0
Future.BOX x1%, y1%, x2% - 1, y2% - 1, RGB2Color(192, 192, 192)
Future.BOX x1% + 1, y1% + 1, x2% - 1, y2% - 1, RGB2Color(128, 128, 128)
Future.BOX x1% + 1, y1% + 1, x2% - 2, y2% - 2, &HFFFFFF
Future.TriGour x1% + 2, y1% + 2, x2% - 2, y1% + 2, x2% - 2, y2% - 2, RGB2Color(255, 255, 255), RGB2Color(192, 192, 192), RGB2Color(128, 128, 128)
Future.TriGour x1% + 2, y1% + 2, x1% + 2, y2% - 2, x2% - 2, y2% - 2, RGB2Color(255, 255, 255), RGB2Color(192, 192, 192), RGB2Color(128, 128, 128)
END SUB

SUB makebutton (x%, y%, x2%, strg$, SIGN%, Index%)
'   Parameters in FUNCTION LOADRTI
'   -------------------------
'   X%      = X Position of the button
'   Y%      = Y Position of the button
'   X2%     = Width of the button
'   STRG$   = A string for the Text in the button
'   SIGN%   = A boolean: indicating a sign is needed or not around the button
'   INDEX%  = An Unique index identifying the button

'------------------------Begin of SUBCODE------------------------------------------
	BTENTRY(Index%).startx = x%
	BTENTRY(Index%).starty = y%
	BTENTRY(Index%).bwidth = x2%

	'future.MouseOFF
	IF SIGN% THEN
	'                  PSET (X% - 2, y% - 4), FORECOLOR
	'                  DRAW "R" + STR$(X2% + 4) + "FRF2DFD17GDG2LGL" + STR$(X2% + 4)
	'                  DRAW "HLH2UHU17EUE2RE"
	'                  DRAW "DR" + STR$(X2% + 4) + "FRFDFD17GDGLGL" + STR$(X2% + 4)
	'                  DRAW "HLHUHU17EUE2R"
	'                  DRAW "DR" + STR$(X2% + 4) + "DR2DDRD17LD2L2DL" + STR$(X2% + 4)
	'                  DRAW "UL2U2LU17RU2R2H"
	END IF
length% = x2%
Caption$ = strg$
Future.BOX x%, y%, x% + length%, y% + 24, 0
Future.BOX x%, y%, x% + length% - 1, y% + 23, &HFFFFFF
Future.BOX x% + 1, y% + 1, x% + length% - 1, y% + 23, RGB2Color(128, 128, 128)
Future.BOX x% + 1, y% + 1, x% + length% - 2, y% + 22, RGB2Color(220, 220, 220)
Future.FILLBOX x% + 2, y% + 2, x% + length% - 2, y% + 22, RGB2Color(192, 192, 192)
Future.TriGour x% + 2, y% + 2, x% - 2 + length%, y% + 2, x% - 2 + length%, y% + 22, RGB2Color(255, 255, 255), RGB2Color(192, 192, 192), RGB2Color(128, 128, 128)
Future.TriGour x% + 2, y% + 2, x% + 2, y% + 22, x% + length% - 2, y% + 22, RGB2Color(255, 255, 255), RGB2Color(192, 192, 192), RGB2Color(128, 128, 128)

IF LEN(Caption$) * 8 >= length% - 16 THEN Caption$ = MID$(Caption$, 1, INT((length% - 16) / 8))
future.print x% + length% / 2 - LEN(Caption$) * 4, y% + 6, Caption$, 0, -1
END SUB

SUB MAKEEXIT (x%, y%, Index%)

EXITENTRY(Index%).startx = x%
EXITENTRY(Index%).starty = y%

END SUB

SUB MakeFrame (x1%, y1%, x2%, y2%, Title$)
Future.BOX x1%, y1%, x2% - 1, y2% - 1, RGB2Color(128, 128, 128)
Future.BOX x1% + 1, y1% + 1, x2%, y2%, &HFFFFFF
future.print x1% + 12, y1% - 6, Title$, 0, RGB2Color(192, 192, 192)
END SUB

SUB makeinputbox (x%, y%, length2%, instring$, Index%)
inputboxes(Index%).startx = x%
inputboxes(Index%).starty = y%
inputboxes(Index%).with = length2%

 Future.BOX x%, y%, x% + length2%, y% + 24, &HFFFFFF
 Future.BOX x%, y%, x% + length2% - 1, y% + 23, RGB2Color(128, 128, 128)
 Future.BOX x% + 1, y% + 1, x% + length2% - 1, y% + 23, RGB2Color(220, 220, 220)
 Future.BOX x% + 1, y% + 1, x% + length2% - 2, y% + 22, &H0
 Future.FILLBOX x% + 2, y% + 2, x% + length2% - 2, y% + 22, &HFFFFFF
 future.print x% + 4, y% + 6, instring$, 0, -1

END SUB

DEFINT A-Z
SUB makeobjects (formx%, formy%)
Drawwindow formx%, formy%, formx% + 128, formy% + 320, "Objects", 0
END SUB

SUB makepolys
FOR i% = 0 TO maxpoints
onpoint4% = (muisx% >= points(i%).XView - 2 AND muisy% >= points(i%).YView - 2 AND muisx% <= points(i%).XView + 2 AND muisy% <= points(i%).YView + 2)
IF onpoint% OR onpoint2% OR onpoint3% OR onpoint4% THEN
Future.MouseOFF
Future.BOX points(i%).XView - 4, points(i%).YView - 4, points(i%).XView + 4, points(i%).YView + 4, &HFF0000
future.MOuseON
DO
future.UpdateMouse
onpoint4% = (muisx% >= points(i%).XView - 2 AND muisy% >= points(i%).YView - 2 AND muisx% <= points(i%).XView + 2 AND muisy% <= points(i%).YView + 2)


IF onpoint4% AND Future.MouseB = 1 THEN
			DO
			future.UpdateMouse
			LOOP UNTIL Future.MouseB = 0
	  
    DO
	future.UpdateMouse
	hti% = 0
	FOR hi% = 0 TO maxpoints
		onpoint4% = (muisx% >= points(hi%).XView - 2 AND muisy% >= points(hi%).YView - 2 AND muisx% <= points(hi%).XView + 2 AND muisy% <= points(hi%).YView + 2)
		IF onpoint4% AND hti% = 0 THEN
			Future.LINE points(i%).XView, points(i%).YView, points(hi%).XView, points(hi%).YView, 0, -1
			hti% = 1
		     DO
			future.UpdateMouse
			onpoint4% = (muisx% >= points(hi%).XView - 2 AND muisy% >= points(hi%).YView - 2 AND muisx% <= points(hi%).XView + 2 AND muisy% <= points(hi%).YView + 2)
			IF NOT onpoint4% AND hti% = 1 THEN
		      
			Future.LINE points(i%).XView, points(i%).YView, points(hi%).XView, points(hi%).YView, 0, -1
			Future.LINE points(i%).XView, points(i%).YView, points(hi%).XView, points(hi%).YView, &HFFFFFF, &HAAAA
			hti% = 0
			EXIT DO
			END IF


'------------------------------------secondloop----------------------------
			IF Future.MouseB = 1 AND onpoint4% THEN
		      
			DO
			future.UpdateMouse
			LOOP UNTIL Future.MouseB = 0
				hti% = 0
				DO
				future.UpdateMouse
				FOR hgi% = 0 TO maxpoints
				onpoint4% = (muisx% >= points(hgi%).XView - 2 AND muisy% >= points(hgi%).YView - 2 AND muisx% <= points(hgi%).XView + 2 AND muisy% <= points(hgi%).YView + 2)
				IF onpoint4% AND hti% = 0 THEN
				Future.LINE points(i%).XView, points(i%).YView, points(hi%).XView, points(hi%).YView, 0, -1
				Future.LINE points(hi%).XView, points(hi%).YView, points(hgi%).XView, points(hgi%).YView, 0, -1
				Future.LINE points(hgi%).XView, points(hgi%).YView, points(i%).XView, points(i%).YView, 0, -1
				hti% = 1
					DO
					future.UpdateMouse
					onpoint4% = (muisx% >= points(hgi%).XView - 2 AND muisy% >= points(hgi%).YView - 2 AND muisx% <= points(hgi%).XView + 2 AND muisy% <= points(hgi%).YView + 2)
					IF Future.MouseB = 1 THEN maxpolys = maxpolys + 1: polys(maxpolys).p1 = i%: polys(maxpolys).p2 = hi%: polys(maxpolys).p3 = hgi%: polys(maxpolys).texture = stexture%: EXIT SUB
					IF NOT onpoint4% AND hti% = 1 THEN
					Future.LINE points(i%).XView, points(i%).YView, points(hi%).XView, points(hi%).YView, &HFFFFFF, -1
					Future.LINE points(hi%).XView, points(hi%).YView, points(hgi%).XView, points(hgi%).YView, &HFFFFFF, -1
					Future.LINE points(hgi%).XView, points(hgi%).YView, points(i%).XView, points(i%).YView, &HFFFFFF, -1
			     
					Future.LINE points(i%).XView, points(i%).YView, points(hi%).XView, points(hi%).YView, 0, &HAAAA
					Future.LINE points(hi%).XView, points(hi%).YView, points(hgi%).XView, points(hgi%).YView, 0, &HAAAA
					Future.LINE points(hgi%).XView, points(hgi%).YView, points(i%).XView, points(i%).YView, 0, &HAAAA
					hti% = 0
					EXIT DO
				     END IF
				    LOOP
				  END IF
				NEXT
			       LOOP
		     END IF

'-----------------------------------first loop-----------------------------


		     LOOP
	  END IF
    NEXT
    LOOP UNTIL Future.MouseB = 2
END IF
'-----------------------------------------------------------------
IF onpoint% AND Future.MouseB = 1 THEN
	zoom% = 2
	viewx1% = 200: viewy1% = 200
 
   oldpointx% = points(i%).xobject / zoom%
   oldpointy% = points(i%).yobject / zoom%

   DO
	     future.UpdateMouse

	     points(i%).xobject = (muisx% - viewx1%) * zoom%'+ oldpointx%' - oldpointx% * zoom%'+ points(i%).xobject
	     points(i%).yobject = (muisy% - viewy1%) * zoom%'+ oldpointy%' - oldpointy% * zoom%'+ points(i%).yobject
Future.MouseOFF
'DrawShit
future.MOuseON
   LOOP UNTIL Future.MouseB = 0

END IF
IF onpoint2% AND Future.MouseB = 1 THEN
	zoom% = 2
	viewx1% = 200: viewy1% = 200

   oldpointx% = points(i%).xobject / zoom%
   oldpointy% = points(i%).zobject / zoom%

   DO
	     future.UpdateMouse

	     points(i%).xobject = (muisx% - viewx2%) * zoom%'+ oldpointx%' - oldpointx% * zoom%'+ points(i%).xobject
	     points(i%).zobject = (muisy% - viewy2% - 380) * zoom%'+ oldpointy%' - oldpointy% * zoom%'+ points(i%).yobject
Future.MouseOFF
'DrawShit
future.MOuseON
   LOOP UNTIL Future.MouseB = 0
END IF


LOOP UNTIL onpoint% = 0 AND onpoint2% = 0 AND onpoint3% = 0 AND onpoint4% = 0
Future.MouseOFF

'Future.BOX formx% + viewx3% + 400 + (Points(I%).zobject / zoom%) - 4, formy% + viewy3% + (Points(I%).yobject / zoom%) - 4, formx% + viewx3% + 400 + (Points(I%).zobject / zoom%) + 4, formy% + viewy3% + (Points(I%).yobject / zoom%) + 4, &H0
'Future.BOX formx% + viewx1% + (Points(I%).xobject / zoom%) - 4, formy% + viewy1% + (Points(I%).yobject / zoom%) - 4, formx% + viewx1% + (Points(I%).xobject / zoom%) + 4, formy% + viewy1% + (Points(I%).yobject / zoom%) + 4, &H0
'Future.BOX formx% + viewx2% + (Points(I%).xobject / zoom%) - 4, formy% + viewy2% + 380 + (Points(I%).zobject / zoom%) - 4, formx% + viewx2% + (Points(I%).xobject / zoom%) + 4, formy% + viewy2% + 380 + (Points(I%).zobject / zoom%) + 4, &H0

Future.BOX points(i%).XView - 4, points(i%).YView - 4, points(i%).XView + 4, points(i%).YView + 4, 0
	frmx% = 843
	treelist$(0) = "Object.3dt"
	treelist$(1) = "Object.3dt\not objected"
	treelist$(2) = "Object.3dt\not objected\points"
	FOR a% = 0 TO maxpoints
	treelist$(3 + a%) = "Object.3dt\not objected\points\point " + STR$(a%)
	NEXT
	treelist$(4 + maxpoints) = "Object.3dt\not objected\polys"
	FOR j% = 0 TO maxpolys
	treelist$(5 + maxpoints + j%) = "Object.3dt\not objected\polys\poly " + STR$(j%)
      NEXT

	treelist$(6 + maxpoints + maxpolys) = "Object.3dt\objects"
	Drawtree frmx% + 6, frmy% + 30, 140, 265, starttr%, treelist$(), iconlist$()

future.MOuseON
END IF

NEXT

END SUB

FUNCTION muisx%
muisx% = Future.MouseX
END FUNCTION

FUNCTION muisy%
muisy% = Future.MouseY
END FUNCTION

SUB Refresh
REDIM treelist$(700)
'treelist$(0) = "Object.3dt"
'treelist$(1) = "Object.3dt\not objected"
'treelist$(2) = "Object.3dt\not objected\points"
'FOR i% = 0 TO maxpoints
'treelist$(3 + i%) = "Object.3dt\not objected\points\point " + STR$(i%)
'NEXT
'treelist$(4 + maxpoints) = "Object.3dt\not objected\polys"
'FOR j% = 0 TO maxpolys
'treelist$(5 + maxpoints + j%) = "Object.3dt\not objected\polys\poly " + STR$(j%)
'NEXT
'treelist$(6 + maxpoints + maxpolys) = "Object.3dt\objects"
Menus$(0, 0) = "Delete"
Menus$(1, 0) = "Set location"
Menus$(2, 0) = "Set color"
drawobjectbox 843, 0
zoom% = 5   '1:2

frame1x% = 200
frame1y% = 200
frame3x% = 600
frame3y% = 200
frame2x% = 200
frame2y% = 600

drawxy zoom%, frame1x%, frame1y%
drawzy zoom%, 600, 200
drawxz zoom%, 200, 600
    SetViewPort 422, 397, 840, 765
    RotatePoints
    CullPolygons
    ShadePolygons
    Future.CLS RGB2Color(255, 255, 255)
    Drawobject drawmode%
    FOR z = 0 TO maxpoints
	Future.FILLBOX (points(z).XView - 2), (points(z).YView) - 2, (points(z).XView) + 2, (points(z).YView) + 2, RGB2Color(128, 128, 128)
    NEXT
    SetViewPort 0, 0, 1024, 768

END SUB

SUB RotatePoints

    'lookup the sine and cosine of each angle...
    s1& = SineTable(r1): C1& = SineTable(r1 + 90)
    s2& = SineTable(r2): C2& = SineTable(r2 + 90)
    s3& = SineTable(r3): C3& = SineTable(r3 + 90)

    'rotate the points of the object
    FOR a = 0 TO maxpoints
	xo = points(a).xobject
	yo = points(a).yobject
	zo = points(a).zobject
	GOSUB Rotate3D

	points(a).XView = formx% + 600 + (x2 * 400&) \ z3
	points(a).YView = formy% + 600 + (Y3 * 300&) \ z3
      
	'IF y3 > 300 THEN STOP

	points(a).XWorld = x2
	points(a).YWorld = Y3
	points(a).zworld = z3
    NEXT
    'rotate the normals of each polygon...
    FOR a = 0 TO maxpolys
	xo = polys(a).WorldXN
	yo = polys(a).WorldYN
	zo = polys(a).WorldZN
	GOSUB Rotate3D
	p1 = polys(a).p1
	'unorigin the point
	x2 = x2 - points(p1).XWorld
	Y3 = Y3 - points(p1).YWorld
	z3 = z3 - points(p1).zworld
	'check the bounds just in case of a round off error
	IF x2 < -128 THEN x2 = -128 ELSE IF x2 > 128 THEN x2 = 128
	IF Y3 < -128 THEN Y3 = -128 ELSE IF Y3 > 128 THEN Y3 = 128
	IF z3 < -128 THEN z3 = -128 ELSE IF z3 > 128 THEN z3 = 128
	'store the normal back; it's now ready for the shading
	'calculations (which are simplistic now)
	polys(a).NormalX = x2 + 128
	polys(a).NormalY = Y3 + 128
	polys(a).NormalZ = z3 + 128
    NEXT
    EXIT SUB

Rotate3D:
    x1 = (xo * C1& - zo * s1&) \ 1024 'yaw
    z1 = (xo * s1& + zo * C1&) \ 1024

    z3 = (z1 * C3& - yo * s3&) \ 1024 + oz 'pitch
    y2 = (z1 * s3& + yo * C3&) \ 1024

    x2 = (x1 * C2& + y2 * s2&) \ 1024 + ox 'roll
    Y3 = (y2 * C2& - x1 * s2&) \ 1024 + oy

RETURN
END SUB

SUB save
Future.MouseOFF
background% = AllExpMem%(256000)
Future.emsget 400, 300, 700, 470, background%
Drawwindow 400, 300, 300, 170, "Save file As", 2
future.print 410, 330, "Path:", 0, -1
fpath$ = "c:\"
makeinputbox 410, 350, 280, "c:\", 0
future.print 410, 380, "Filename:", 0, -1
ffilename$ = ".3dt "
makeinputbox 410, 400, 280, ".3dt", 1
makebutton 410, 440, 135, "Save", 0, 11
makebutton 555, 440, 135, "Cancel", 0, 12
future.MOuseON
DO
future.UpdateMouse
IF path$ > "" THEN fpath$ = path$
path$ = DoInputBox(fpath$, 0)
IF filename$ > "" THEN ffilename$ = filename$
filename$ = DoInputBox(ffilename$, 1)

dummy& = BUTTONPUSHED(11, "Save")
dummy& = BUTTONPUSHED(12, "Cancel")

IF EXITPUSHED%(2) OR BTPUSHED%(12) THEN
Future.MouseOFF
future.emsput 400, 300, background%
EXIT DO

END IF

LOOP
future.MOuseON
END SUB

SUB ShadePolygons
    FOR a = 0 TO maxpolys
	IF polys(a).culled = False THEN

	 'lookup the polygon's normal for shading
	 '(128*128)\15 = 1092
	 intensity = (lx(polys(a).NormalX) + ly(polys(a).NormalY) + lz(polys(a).NormalZ)) \ 1092
	 IF intensity < 0 THEN intensity = 0
	 intensity = intensity + 5
	 IF intensity > 15 THEN intensity = 15

	 polys(a).intensity = intensity
	END IF
    NEXT
END SUB

