DECLARE SUB DoCapture ()
DECLARE SUB doxz ()

DECLARE SUB welcomescreen ()
DECLARE SUB drawxz ()
DECLARE SUB draw3d ()
DECLARE SUB Clearvideobuffer ()
DECLARE SUB Drawobject ()
DECLARE SUB doobjects ()
DECLARE SUB Makeobject (name$, npoints%, sizex%, sizey%, sizez%, texture%)
DECLARE SUB DrawObjectbox ()
DECLARE SUB Drawstrucbox ()
DECLARE SUB dotab ()
DECLARE SUB dotoolbar ()
DECLARE SUB DrawTextureBox ()
DECLARE SUB drawactivetab ()
DECLARE SUB simplebox (X1%, Y1%, x2%, y2%)
DECLARE SUB saveoldfile (filename$)
DECLARE SUB Drawpolys (sl%)
DECLARE SUB moveobject ()
DECLARE SUB checkmenubutton (Index%)
DECLARE SUB makemenubutton (x%, y%, caption$, menu%, Index%)
DECLARE SUB drawmenubutton (x%, y%, caption$, Mode%)
DECLARE SUB drawbutton (X1%, Y1%, x2%, y2%, caption$, Mode%, Index%)
DECLARE SUB makebutton (X1%, Y1%, x2%, caption$, icon$, Index%)
DECLARE SUB changecolor (X1%, Y1%, x2%, y2%, rch%, gch%, bch%)
DECLARE FUNCTION oneditscreen% ()
DECLARE SUB setup ()
DECLARE SUB rotatepoints ()
DECLARE SUB Cullpolygons ()
DECLARE SUB ShadePolygons ()
DECLARE SUB Findnormals ()
DECLARE SUB putxms (var%, Index%, dat%)
DECLARE FUNCTION getxms% (var%, Index%)
DECLARE SUB draweditscreen ()
DECLARE SUB Message (caption$, Msg$, errorsgn%, btns%, outp%)
DECLARE SUB checkcb (Index%)
DECLARE SUB makecheckbutton (x%, y%, caption$, Index%, onof%)
DECLARE SUB drawcheckbutton (x%, y%, caption$, onof%)
DECLARE SUB config ()
DECLARE SUB checkbutton (Index%, pushed%)
DECLARE FUNCTION doinputbox$ (Index%)
DECLARE SUB makeinputbox (X1%, Y1%, x2%, Index%)
DECLARE SUB inform (X1%, Y1%, x2%, y2%)
DECLARE SUB Closeform (Index%)
DECLARE SUB Makeform (X1%, Y1%, x2%, y2%, caption$, Index%)
DECLARE FUNCTION selectfile$ ()
DECLARE SUB drawexplorer ()
DECLARE SUB closemenu (Index%)
DECLARE FUNCTION domenu% (Index%)
DECLARE SUB UpdateMOuse ()
DECLARE SUB openmenu (x%, y%, Index%)
DECLARE SUB drawbar (X1%, Y1%, x2%, y2%)
REM $INCLUDE: 'future.bi'
REM $DYNAMIC

CONST True = -1, False = 0
TYPE FileFindBuf
    DOS            AS STRING * 19
    CreateTime     AS STRING * 1
    Attributes     AS INTEGER
    AccessTime     AS INTEGER
    AccessDate     AS INTEGER
    filesize       AS LONG
    filename       AS STRING * 13
END TYPE
TYPE Register
    ax    AS INTEGER
    bx    AS INTEGER
    CX    AS INTEGER
    dx    AS INTEGER
    Bp    AS INTEGER
    Si    AS INTEGER
    Di    AS INTEGER
    Flags AS INTEGER
    Ds    AS INTEGER
    Es    AS INTEGER
END TYPE
TYPE inputboxs
    x AS INTEGER
    y AS INTEGER
    length AS INTEGER
END TYPE
TYPE formstats
     x AS INTEGER
     y AS INTEGER
     back AS INTEGER
     with AS INTEGER
     heigth AS INTEGER
     caption AS STRING * 20
END TYPE
TYPE texttype                           'define text settings
     Col AS LONG
     size AS INTEGER
     link AS INTEGER
END TYPE
TYPE linktype                           'define link settings
     x AS INTEGER
     y AS INTEGER
     length AS INTEGER
END TYPE

TYPE buttont
   x AS INTEGER
   y AS INTEGER
   with AS INTEGER
   pushed AS INTEGER
   onmouse AS INTEGER
END TYPE

TYPE checkbt
    x AS INTEGER
    onoff AS INTEGER
    y AS INTEGER
END TYPE
TYPE menutype
     Text AS STRING * 17
     'link AS STRING * 8
     menuname AS STRING * 18
     back AS INTEGER
     'icon AS STRING * 12
     lng AS INTEGER
     x AS INTEGER
     y AS INTEGER

END TYPE
TYPE PointType
    xobject     AS INTEGER 'original coordinate
    yobject     AS INTEGER
    zobject     AS INTEGER 'rotated coordinate
    objects     AS INTEGER
    xworld      AS INTEGER
    yworld      AS INTEGER
    zworld      AS INTEGER
    xview       AS INTEGER 'rotated & translated coordinate
    yview       AS INTEGER

END TYPE
TYPE PolyType
    p1          AS INTEGER '3 points which make up the polygon (points
    p2          AS INTEGER 'to the point list array)
    p3          AS INTEGER
    culled      AS INTEGER 'True if plane not visible
    zcenter     AS INTEGER 'Z center of polygon
    zorder      AS INTEGER 'Used in the shell sort of the ZCenters
    intensity   AS INTEGER 'Intensity of polygon
    worldxn     AS INTEGER 'Contains the coordinates of the point
    worldyn     AS INTEGER ' which is both perpendicular and a constant
    worldzn     AS INTEGER ' distance from the polygon
    normalx     AS INTEGER 'Normal of polygon -128 to 128
    normaly     AS INTEGER ' (used for fast Lambert shading)
    normalz     AS INTEGER
    objects     AS INTEGER 'on wich object are the polys
    texture     AS INTEGER 'the texture for a poly
END TYPE
TYPE objects
            StartPoly AS INTEGER   'the poly where the object starts
            endpoly AS INTEGER     'the poly where the objects ends
            endpoint  AS INTEGER   'the point where the object starts
            startpoint AS INTEGER  'the point where the object ends
            naam AS STRING * 6     'name of the object
            texture AS INTEGER     'the texture of an object
END TYPE

DIM SHARED inputbox(9) AS inputboxs     'define inputbox varibles
DIM SHARED inputtext$(9)                'define the values for the inputbox
DIM SHARED form(9) AS formstats

DIM SHARED button(39) AS buttont
DIM SHARED bcaption$(39), fold$
DIM SHARED menubut(29) AS buttont
DIM SHARED menucaption$(12)

DIM SHARED buttonicon$(39)

DIM SHARED checkb(20) AS checkbt
DIM SHARED checkcaption$(20)


DIM SHARED menu(5, 14) AS menutype, dirlist$(1), dirlen%, dirlink$(10), diricon$(10)
DIM SHARED Mousex%, Mousey%, resx%, resy%, folder$, maxobjects

DIM SHARED object(50) AS objects
DIM SHARED bytes&, activetab%
DIM SHARED SineTable(359 + 90) AS LONG 'cos(x)=sin(x+90)
DIM SHARED r1, r2, r3, ox, oy, oz
DIM SHARED maxpoints, maxpolys
DIM SHARED Lx(256), Ly(256), Lz(256)  'lookup tables for Lambert shading
DIM SHARED texture(44) AS INTEGER, maxtextures AS INTEGER
DIM SHARED Lx, Ly, Lz
DIM SHARED viewtool%, tool%, xp1%, zp1%, xp2%, zp2%, xp3%, zp3%
DIM SHARED polys AS PolyType   'free memory
DIM SHARED PI   AS LONG, zoomxz%, zoomxy%, zoomzy%, newtime&, starttime&, fps!

