DECLARE SUB putxms (var%, index%, dat%)
DECLARE FUNCTION getxms% (var%, index%)


DECLARE SUB makeobject (name$, npoints%, size%)
DECLARE SUB setup ()
DECLARE SUB Cullpolygons ()
DECLARE SUB DrawObject ()
DECLARE SUB Findnormals ()
DECLARE SUB rotatepoints ()
DECLARE SUB ShadePolygons ()
REM $DYNAMIC

REM $INCLUDE: 'FUTURE.BI'
'---------------Object Variables needed for Rush Objects--------------------


CONST True = -1, False = 0
TYPE PointType
    xobject     AS INTEGER 'original coordinate
    yobject     AS INTEGER
    zobject     AS INTEGER 'rotated coordinate
    xworld      AS INTEGER
    yworld      AS INTEGER
    zworld      AS INTEGER
    xview       AS INTEGER 'rotated & translated coordinate
    yview       AS INTEGER

END TYPE
TYPE PolyType
    p1          AS INTEGER '3 points which make up the polygon (points
    p2          AS INTEGER 'to the point list array)
    p3          AS INTEGER
    culled      AS INTEGER 'True if plane not visible
    zcenter     AS INTEGER 'Z center of polygon
    zorder      AS INTEGER 'Used in the shell sort of the ZCenters
    intensity   AS INTEGER 'Intensity of polygon
    worldxn     AS INTEGER 'Contains the coordinates of the point
    worldyn     AS INTEGER ' which is both perpendicular and a constant
    worldzn     AS INTEGER ' distance from the polygon
    normalx     AS INTEGER 'Normal of polygon -128 to 128
    normaly     AS INTEGER ' (used for fast Lambert shading)
    normalz     AS INTEGER
'    texture     AS INTEGER
END TYPE
DIM SHARED polytext(5000)
DIM SHARED bytes&
bytes& = 4                      'set number of bytes for integers i think 4 will be enough
DIM SHARED SineTable(359 + 90) AS LONG 'cos(x)=sin(x+90)
DIM SHARED r1, R2, R3, ox, oy, oz, texture%(20)
DIM SHARED maxpoints, maxpolys, resx%, resy%
DIM SHARED PI   AS LONG
PI = 3.141593                                                           'pi
DIM SHARED polys AS PolyType                                            'free memory
polys.p1 = Allocatexms%(25600)
polys.p2 = Allocatexms%(25600)
polys.p3 = Allocatexms%(25600)
polys.culled = Allocatexms%(25600)
polys.zcenter = Allocatexms%(25600)
polys.zorder = Allocatexms%(25600)
polys.intensity = Allocatexms%(25600)
polys.worldxn = Allocatexms%(25600)
polys.worldyn = Allocatexms%(25600)
polys.worldzn = Allocatexms%(25600)
polys.normalx = Allocatexms%(25600)
polys.normaly = Allocatexms%(25600)
polys.normalz = Allocatexms%(25600)
DIM SHARED points AS PointType
points.xobject = Allocatexms%(25600)
points.yobject = Allocatexms%(25600)
points.zobject = Allocatexms%(25600)
points.xworld = Allocatexms%(25600)
points.yworld = Allocatexms%(25600)
points.zworld = Allocatexms%(25600)
points.xview = Allocatexms%(25600)
points.yview = Allocatexms%(25600)



DIM SHARED Lx(256), Ly(256), Lz(256)  'lookup tables for Lambert shading

DIM SHARED Lx, Ly, Lz
 DIM SHARED r%



'---------------------SUBS needed for Rush apllication---------------------
'loadobject "object.3dt"
'DO
resetscreen
SCREEN 0, 0, 0, 0
PRINT "3dobject generator"
PRINT "This demo will show in 3d a planet that circles around the sun. The"
PRINT "number of sides% is the numer of points for each circle and the "
PRINT "number of circles. So total number of points is sides% ^ 2"
PRINT "Thoose not to high and if you choose higher then 24 you will get "
PRINT "errors "
PRINT "Press right mousebutton to end the program"

PRINT "I tested it on a AMD DURON 650 and it doesn't lacks but on intel"
PRINT "shit it wil be very slow, hihi"
PRINT ""
PRINT "AMD POWER!!!!!!!!!, program by cyrix (cyrixramon@yahoo.com)"

IF IsMMX% THEN PRINT "MMX supported"': SetMMX 1
PRINT ""
 PRINT " loading......"

DIM SHARED tv%

file$ = "objects\globe\7side.obj"           'choose a file"
OPEN file$ FOR INPUT AS #1
	INPUT #1, inline$          ' input number of points etc.
	maxpoints = VAL(inline$)
	FOR i% = 0 TO maxpoints
		INPUT #1, inline$
		putxms points.xobject, i%, VAL(inline$)
		INPUT #1, inline$
		putxms points.yobject, i%, VAL(inline$)
		INPUT #1, inline$
		putxms points.zobject, i%, VAL(inline$)
		 
	NEXT
	INPUT #1, inline$
	maxpolys = VAL(inline$)
	FOR i% = 0 TO maxpolys
		INPUT #1, inline$
		putxms polys.p1, i%, VAL(inline$)
		INPUT #1, inline$
		putxms polys.p2, i%, VAL(inline$)
		INPUT #1, inline$
		putxms polys.p3, i%, VAL(inline$)
	NEXT
CLOSE #1

 
setup
R2 = 180                                        'set rotation y and z
R3 = 145

Future.MouseON                                  'switch mouse on
    Findnormals                                 'find normal of each polygon
    rotatepoints                                'rotate the 3d points en normals
    Cullpolygons                                'surfacehiding
    ShadePolygons                               'Shade polygons
    DrawObject                                  'zbuffer and draw the obeject
starttime& = TIMER
DO
Future.UpdateMouse
fps% = fps% + 1                                                                         'calc fps
newtime& = TIMER
IF newtime& - starttime& >= 1 THEN fpsv$ = STR$(fps%): fps% = 0: starttime& = TIMER
   
    rotatepoints
    Cullpolygons
    ShadePolygons
    future.print 0, 0, fpsv$, RGB2Color(255, 255, 255), -1
    DrawObject
 
    oz = oz + dz: ox = ox + dx

ox = 0

   IF Future.MouseB = 1 THEN future.snapshot "c:\windows\desktop\shot1004.bmp"
r1 = r1 + 1
'r1 =
R2 = 350
R3 = 330
IF r1 >= 358 THEN r1 = 1
LOOP UNTIL Future.MouseB = 2
resetscreen


Deallocatexms polys.p1 '= Allocatexms%(25600)
Deallocatexms polys.p2' = Allocatexms%(25600)
Deallocatexms polys.p3' = Allocatexms%(25600)
Deallocatexms polys.culled' = Allocatexms%(25600)
Deallocatexms polys.zcenter '= Allocatexms%(25600)
Deallocatexms polys.zorder '= Allocatexms%(25600)
Deallocatexms polys.intensity' = Allocatexms%(25600)
Deallocatexms polys.worldxn '= Allocatexms%(25600)
Deallocatexms polys.worldyn '= Allocatexms%(25600)
Deallocatexms polys.worldzn' = Allocatexms%(25600)
Deallocatexms polys.normalx '= Allocatexms%(25600)
Deallocatexms polys.normaly' = Allocatexms%(25600)
Deallocatexms polys.normalz '= Allocatexms%(25600)
Deallocatexms points.xobject' = Allocatexms%(25600)
Deallocatexms points.yobject' = Allocatexms%(25600)
Deallocatexms points.zobject' = Allocatexms%(25600)
Deallocatexms points.xworld '= Allocatexms%(25600)
Deallocatexms points.yworld' = Allocatexms%(25600)
Deallocatexms points.zworld' = Allocatexms%(25600)
Deallocatexms points.xview' = Allocatexms%(25600)
Deallocatexms points.yview' = Allocatexms%(25600)

'FOR i% = 0 TO 9
'deallexpmem texture%(i%)
'NEXT

REM $STATIC
SUB Cullpolygons
'This algorithm for removing hidden faces was developed by Dave
'Cooper.
    'There is another method, by finding the dot product of the
    'plane's normal and the viewing vector, but this algorithm is
    'much faster because of its simplicity(and lack of floating point
    'calculations).
    FOR a = 0 TO maxpolys
	p1 = getxms%(polys.p1, a)
	p2 = getxms%(polys.p2, a)
	p3 = getxms%(polys.p3, a)

	IF getxms%(points.yview, p1) <= getxms%(points.yview, p2) THEN
	    IF getxms%(points.yview, p3) < getxms%(points.yview, p1) THEN
		PTop = p3
		PNext = p1
		PLast = p2
	    ELSE
		PTop = p1
		PNext = p2
		PLast = p3
	    END IF
	ELSE
	    IF getxms%(points.yview, p3) < getxms%(points.yview, p2) THEN
		PTop = p3
		PNext = p1
		PLast = p2
	    ELSE
		PTop = p2
		PNext = p3
		PLast = p1
	    END IF
	END IF

	XLow = getxms%(points.xview, PTop)
	YLow = getxms%(points.yview, PTop)

	XNext = getxms%(points.xview, PNext)
	XLast = getxms%(points.xview, PLast)

	IF XNext <= XLow AND XLast >= XLow THEN
	    putxms polys.culled, a, True
	ELSEIF XNext >= XLow AND XLast <= XLow THEN
	    putxms polys.culled, a, False
	ELSE
	    YNext = getxms%(points.yview, PNext)
	    YLast = getxms%(points.yview, PLast)
IF ((YNext - YLow) * 256&) \ (XNext - XLow) < ((YLast - YLow) * 256&) \ (XLast - XLow) THEN
		putxms polys.culled, a, False
	    ELSE
		putxms polys.culled, a, True
	    END IF
	END IF

    NEXT
END SUB

SUB DrawObject


    'Find the center of each visible polygon, and prepare the orderlist.
    numpolys = 0
    FOR a = 0 TO maxpolys
	IF getxms%(polys.culled, a) = False THEN 'is this polygon visible?
	   
	    putxms polys.zorder, numpolys, a
	    numpolys = numpolys + 1
	    zc% = getxms%(points.zworld, getxms%(polys.p1, a)) + getxms%(points.zworld, getxms%(polys.p2, a)) + getxms%(points.zworld, getxms%(polys.p3, a))
	    putxms polys.zcenter, a, INT(zc% / 3)
	END IF
    NEXT
    'Sort the visible polygons by their Z center using a shell sort.
    numpolys = numpolys - 1
    Mid = (numpolys + 1) \ 2
    DO
	FOR a = 0 TO numpolys - Mid
	    CompareLow = a
	    CompareHigh = a + Mid
		DO WHILE getxms%(polys.zcenter, getxms%(polys.zorder, CompareLow)) < getxms%(polys.zcenter, getxms%(polys.zorder, CompareHigh))
		am% = getxms%(polys.zorder, CompareLow)
		bm% = getxms%(polys.zorder, CompareHigh)
		SWAP am%, bm%
		putxms polys.zorder, CompareLow, am%
		putxms polys.zorder, CompareHigh, bm%
		CompareHigh = CompareLow
		CompareLow = CompareLow - Mid
		IF CompareLow < 0 THEN EXIT DO
	    LOOP
	NEXT
	Mid = Mid \ 2
    LOOP WHILE Mid > 0
    'Plot the visible polygons.





 
	viewpage r%
	r% = r% + 1
	IF r% = 2 THEN r% = 0
setpage r%
	
       
       future.cls 0 'RGB2Color(255, 255, 255)
    FOR z = 0 TO numpolys
	a = getxms%(polys.zorder, z)'which polygon do we plot?
	p1 = getxms%(polys.p1, a): p2 = getxms%(polys.p2, a): p3 = getxms%(polys.p3, a)
	Future.Trifill getxms%(points.xview, p1), getxms%(points.yview, p1), getxms%(points.xview, p2), getxms%(points.yview, p2), getxms%(points.xview, p3), getxms%(points.yview, p3), getxms%(polys.intensity, a) * RGB2Color(0, 0, 128)
	'       Future.Emstritext getxms%(points.xview, p1), getxms%(points.yview, p1), getxms%(points.xview, p2), getxms%(points.yview, p2), getxms%(points.xview, p3), getxms%(points.yview, p3), 0, 0, 64, 32, 0, 64, texture%(polytext(a))
    NEXT
END SUB

SUB Findnormals
    FOR a = 0 TO maxpolys
	p1 = getxms%(polys.p1, a): p2 = getxms%(polys.p2, a): p3 = getxms%(polys.p3, a)
   
	'find the vectors of 2 lines inside the polygon
	ax! = getxms%(points.xobject, p2) - getxms%(points.xobject, p1)
	ay! = getxms%(points.yobject, p2) - getxms%(points.yobject, p1)
	az! = getxms%(points.zobject, p2) - getxms%(points.zobject, p1)
   
	bx! = getxms%(points.xobject, p3) - getxms%(points.xobject, p2)
	by! = getxms%(points.yobject, p3) - getxms%(points.yobject, p2)
	bz! = getxms%(points.zobject, p3) - getxms%(points.zobject, p2)
   
	'find the cross product of the 2 vectors
	nx! = ay! * bz! - az! * by!
	ny! = az! * bx! - ax! * bz!
	nz! = ax! * by! - ay! * bx!
   
	'normalize the vector so it ranges from -1 to 1
	M! = SQR(nx! * nx! + ny! * ny! + nz! * nz!)
	IF M! <> 0 THEN nx! = nx! / M!: ny! = ny! / M!: nz! = nz! / M!
	'store the vector for later rotation(notice that it is scaled
	'up by 128 so it can be stored as an integer variable)
	putxms polys.worldxn, a, (nx! * 128 + getxms%(points.xobject, p1))
	'polys(a).worldxn = nx! * 128 + points(p1).xobject
	putxms polys.worldyn, a, (ny! * 128 + getxms%(points.yobject, p1))
	'polys(a).worldyn = ny! * 128 + points(p1).yobject
	putxms polys.worldzn, a, (na! * 128 + getxms%(points.zobject, p1))
	'polys(a).worldzn = nz! * 128 + points(p1).zobject
    NEXT
END SUB

FUNCTION getxms% (var%, index%)
movefromxms var%, VARSEG(gtmx%), VARPTR(gtmx%), 4, index% * 4
getxms% = gtmx%
EXIT FUNCTION
END FUNCTION

SUB makeobject (name$, npoints%, size%)
pointstep% = 360 / npoints%
maxpoints% = 0
maxpolys% = 0
    '
    '       FOR h% = 0 TO 360 STEP 360 / npoints%
    '       x% = SIN(h% * PI / 360) * 1000
    '       y% = x%
    '       FOR i% = 0 TO 360 STEP 360 / npoints%
    '          points(maxpoints%).xobject = SIN(i% * PI / 180) * x%
    '          points(maxpoints%).zobject = COS(i% * PI / 180) * x%
    '          points(maxpoints%).yobject = COS(h% * PI / 360) * 1000
    '
    '
    '
    '
    '          '(size% + size% / 2) / 255 * 255
    '          IF maxpoints% > 0 THEN
    '          IF points(maxpoints%).xobject = points(maxpoints% - 1).xobject AND points(maxpoints%).yobject = points(maxpoints% - 1).yobject THEN maxpoints% = maxpoints% - 1
    '          END IF
    '          maxpoints% = maxpoints% + 1
    '       NEXT
    '       NEXT
    '       FOR i% = 0 TO maxpoints
    '       points(i%).xobject = points(i%).xobject * (size% / 1000)
    '       points(i%).yobject = points(i%).yobject * (size% / 1000)
    '       points(i%).zobject = points(i%).zobject * (size% / 1000)
    '       'points(i%).colour = ((points(i%).yobject + size%) / size% * 126)
    '       NEXT
    '       'uppoint of globe
    '       FOR i% = 0 TO npoints% '- 1
    '             polys(maxpolys%).p1 = 0
    '             polys(maxpolys%).p2 = i% + 1
    '             polys(maxpolys%).p3 = i%
    '             maxpolys% = maxpolys% + 1
    '       NEXT
    '             polys(maxpolys%).p1 = 0
    '             polys(maxpolys%).p2 = 1
    '             polys(maxpolys%).p3 = npoints%
    '             maxpolys% = maxpolys% + 1
    '             '
    '
    '
    '             FOR g% = 1 TO npoints% - 1
    '
    '             FOR i% = 1 TO npoints% '- 1
    '             polys(maxpolys%).p1 = g% * npoints% - npoints% + i%
    '             polys(maxpolys%).p2 = g% * npoints% + i% + 1
    '             polys(maxpolys%).p3 = g% * npoints% + i%
    '             maxpolys% = maxpolys% + 1
    '            NEXT
    '
    '            'polys(maxpolys%).p1 = g% * npoints%
    '            'polys(maxpolys%).p2 = g% * npoints% + 1
    '            'polys(maxpolys%).p3 = g% * npoints% + npoints%
    '            maxpolys% = maxpolys% + 1
    '
    '              FOR i% = 1 TO npoints%' - 1
    '             polys(maxpolys%).p1 = g% * npoints% - npoints% + i%
    '             polys(maxpolys%).p2 = g% * npoints% - npoints% + i% + 1
    '             polys(maxpolys%).p3 = g% * npoints% + i% + 1
    '             maxpolys% = maxpolys% + 1
    '
    '            NEXT
    '            'polys(maxpolys%).p1 = g% * npoints%
    '            'polys(maxpolys%).p2 = g% * npoints% - npoints% + 1
    '            'polys(maxpolys%).p3 = g% * npoints% + 1
    '            maxpolys% = maxpolys% + 1
    '
    '             NEXT
    '            g% = npoints%
    '            FOR i% = 1 TO npoints% '- 1
    '             polys(maxpolys%).p1 = g% * npoints% - npoints% + i%
    '             polys(maxpolys%).p2 = g% * npoints% - npoints% + i% + 1
    '             polys(maxpolys%).p3 = g% * npoints% '+ i% + 1
    '             maxpolys% = maxpolys% + 1
'NEXT

'
END SUB

SUB putxms (var%, index%, dat%)
movetoxms var%, VARSEG(dat%), VARPTR(dat%), 4, index% * 4
END SUB

SUB rotatepoints
'    resx% = resx% - 200
xd! = 400& * resx% / 320
yd! = 300& * resy% / 200
    'lookup the sine and cosine of each angle...
    s1& = SineTable(r1): c1& = SineTable(r1 + 90)
    s2& = SineTable(R2): c2& = SineTable(R2 + 90)
    s3& = SineTable(R3): C3& = SineTable(R3 + 90)

    'rotate the points of the object
    FOR a = 0 TO maxpoints
	xo = getxms%(points.xobject, a)
	yo = getxms%(points.yobject, a)
	zo = getxms%(points.zobject, a)
	GOSUB Rotate3D
	
	xview = resx% / 2 + (x2 * xd!) \ z3
	yview = resy% / 2 + (y3 * yd!) \ z3
	putxms points.xview, a, xview
	putxms points.yview, a, yview
	'IF y3 > 300 THEN STOP

	
	putxms points.xworld, a, x2
	putxms points.yworld, a, y3
	putxms points.zworld, a, z3
   NEXT
    'rotate the normals of each polygon...
    FOR a = 0 TO maxpolys
	xo = getxms%(polys.worldxn, a)
	yo = getxms%(polys.worldyn, a)
	zo = getxms%(polys.worldzn, a)
	GOSUB Rotate3D
	p1 = getxms%(polys.p1, a)
	'unorigin the point
	x2 = x2 - getxms%(points.xworld, p1)
	y3 = y3 - getxms%(points.yworld, p1)
	z3 = z3 - getxms%(points.zworld, p1)
	'check the bounds just in case of a round off error
	IF x2 < -128 THEN x2 = -128 ELSE IF x2 > 128 THEN x2 = 128
	IF y3 < -128 THEN y3 = -128 ELSE IF y3 > 128 THEN y3 = 128
	IF z3 < -128 THEN z3 = -128 ELSE IF z3 > 128 THEN z3 = 128
	'store the normal back; it's now ready for the shading
	'calculations (which are simplistic now)
	putxms polys.normalx, a, x2 + 128
	'polys(a).normalx = x2 + 128
	putxms polys.normaly, a, y3 + 128
	'polys(a).normaly = y3 + 128
	putxms polys.normalz, a, z3 + 128
	'polys(a).normalz = z3 + 128
    NEXT
    ' resx% = resx% + 200
    EXIT SUB

Rotate3D:
    x1 = (xo * c1& - zo * s1&) \ 1024 'yaw
    z1 = (xo * s1& + zo * c1&) \ 1024

    z3 = (z1 * C3& - yo * s3&) \ 1024 + oz 'pitch
    y2 = (z1 * s3& + yo * C3&) \ 1024

    x2 = (x1 * c2& + y2 * s2&) \ 1024 + ox 'roll
    y3 = (y2 * c2& - x1 * s2&) \ 1024 + oy

RETURN
END SUB

SUB setup
'setup the program
     set320x200 16
     resx% = 320
     resy% = 200
'loadlaunch "english.lng"

x = x \ (maxpoints + 1): y = y \ (maxpoints + 1): z = z \ (maxpoints + 1)

'Precalculate the normal point of each polygon for fast Lambert shading

Findnormals

'Precalculate the sine table
a = 0

FOR a! = 0 TO (359 + 90) / 57.29 STEP 1 / 57.29
    SineTable(a) = SIN(a!) * 1024: a = a + 1
NEXT

'Some light source configurations won't work that great!



r1 = 0: R2 = 0: R3 = 0      'three angles of rotation
ox = 0: oy = 0: oz = 3000 'object's origin (this program cannot
			    'currently handle the object when it goes
		    'behind the viewer!)
S = 1: T = 0
'future.loadfont "fonts/hylas.fnt"

l1 = 70: l2 = 40           'light source's spherical coordinates
a1! = l1 / 57.29: a2! = l2 / 57.29

s1! = SIN(a1!): c1! = COS(a1!)
s2! = SIN(a2!): c2! = COS(a2!)
Lx = 128 * s1! * c2!        'convert spherical coordinates to a vector
Ly = 128 * s1! * s2!        'scale up by 128 for integer math
Lz = 128 * c1!

FOR a = -128 TO 128         'precalculate the three light source tables
    Lx(a + 128) = Lx * a    'for fast Lambert shading
    Ly(a + 128) = Ly * a
    Lz(a + 128) = Lz * a
NEXT

r1 = 0: R2 = 0: R3 = 0      'three angles of rotation
ox = 0: oy = -50: oz = 1100 'object's origin (this program cannot
			    'currently handle the object when it goes
		    'behind the viewer!)
S = 1: T = 0
END SUB

SUB ShadePolygons
    FOR a = 0 TO maxpolys
	IF getxms%(polys.culled, a) = False THEN
  
	 'lookup the polygon's normal for shading
	 '(128*128)\15 = 1092
	 intensity = (Lx(getxms%(polys.normalx, a)) + Ly(getxms%(polys.normaly, a)) + Lz(getxms%(polys.normalz, a))) \ 1092
	 IF intensity < 0 THEN intensity = 0
	 intensity = intensity + 5
	 IF intensity > 15 THEN intensity = 15
	 putxms polys.intensity, a, intensity
	END IF
    NEXT
END SUB

